//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
/*:#localized( key:"--explain" )
# 1-4. 位置を変える
[前ページで大きさを変えました](@previous)。図形は表示位置を変えることができます。

----------------- 
 1. ``.position( cx:100, cy:100 )``を追加します。cx,cyは図形の中央の座標です。cxはcenter-x, cyはcenter-yの略です。
 
図形の位置をxとyのプラスとマイナスで表現します。下の図はxとyの関係を示す1つの例です。
 
 ![Lilyの座標系の例](lilypg1-1-4-coord.png)
 
 中心は(x:0,y:0)です。xプラスは右方向へ移動し、xマイナスは左方向へ移動します。 yプラスは上方向へ移動、yマイナスは下方向へ移動します。
 
 画面端の値は、画面サイズによって変わります（例：画面の横サイズが100だった場合、x=-50で左端、x=+50で右端になります）。
 
 ````
 func design( screen:PGScreen ) {
    PGRectangle()
    .color( .red )
    .scale( width:200, height:300 )
    .position( cx:100, cy:100 )
 }
 ```` 
 
 2. 「コードを実行」を押します。 

----------------- 
## 目標 
+ 右上に移動した四角が表示されれば成功です。[**結果の例**](glossary://result-1-1-4)
+ **(+1)** cx, cyの値をいろいろ変えてみましょう。

-----------------
 終わったら[次のページ](@next)へ進みます。
 
-----------------  
 - Note:
 positionの初期値は **cx:0, cy:0** です。

-----------------  
 - Note:
 画面端の値は **screen.minX, screen.maxX, screen.minY, screen.maxY** で得ることができます。
 
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
func design( screen:PGScreen ) {
    //#-editable-code
    PGRectangle()
    .color( .red )
    .scale( width:200, height:300 )
    
    //#-end-editable-code
}

//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
