//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, alpha, alpha() )
/*:#localized( key:"--explain" )
# 1-6. 透かす
[1-2で色](1-2.playgroundpage)を取り扱いましたが、色の操作の1つとしてalpha（透明度)の操作があります。ここでは図形を透かしてみます。

----------------- 
 1. PGRectangleに``.alpha( 0.3 )``を追加します。
 
 2. PGRectangleの前にある``screen.clearColor = .white``を``.lightGrey``に書き換えます。
 ````
 func design( screen:PGScreen ) {
    screen.clearColor = .lightGrey
 
    PGRectangle()
    .color( .red )
    .scale( width:200, height:300 )
    .angle( degrees: 45.0 )
    .alpha( 0.3 )
 }
 ```` 
 3. 「コードを実行」を押します。 

----------------- 
## 目標 
+ 薄い灰色の背景に透けた赤の四角が表示されたら成功です。[**結果の例**](glossary://result-1-1-6)
 
-----------------
 終わったら[次のページ](@next)へ進みます。
 
-----------------  
 - Note:
 alphaは**0.0(透明)~1.0(不透明)**の値を指定します。初期値は**1.0**です。
 例えば0.5で半分透明になります。\
 なおalphaは``.color``の``alpha:``でも変更できます。
 
 -----------------  
 - Note:
 ``screen.clearColor = .色`` で背景色を変えられます。\
 ``screen.clearColor = LLColor(赤値,緑値,青値,アルファ値)``で色値を指定して自由な色を作れます。\
 例(オレンジ色): ``screen.clearColor = LLColor( 1.0, 0.5, 0.0, 1.0 )``\
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
func design( screen:PGScreen ) {
    //#-editable-code
    screen.clearColor = .white
    
    PGRectangle()
    .color( .red )
    .scale( width:200, height:300 )
    .angle( degrees: 45.0 )

    //#-end-editable-code
}

//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
