//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, alpha, alpha() )
/*:#localized( key:"--explain" )
# 1-7. フリーコード
[前ページ](1-6.playgroundpage) まででLilyで基本的な図形操作ができるようになりました。ここで一度整理して、[次の章](@next)にのぞみます。
 
-----------------
 + 背景の色を変える:\
 `screen.clearColor = .lightGrey`
 
 + 四角を描く:\
 `PGRectangle()`
 
 + 色を変える:\
 `.color( .cyan )`\
 `.color( red:0.5, green:0.7, blue:1.0 )`
 
 + 大きさを変える:\
 `.scale( width:200, height:300 )` 
 
 + 位置を変える:\
 `.position( cx: -150, cy:100 )` 
  
 + 回転させる:\
 `.angle( degrees:45.0 )` : 360度法\
 `.angle( radians:45.0 * Double.pi / 180.0 )` : 弧度法\
上記の二つの式は同じ効果が得られます。
 
 + 図形を透過する:\
 `.alpha( 0.5 )`  
 
----------------- 
## 目標 
+ 自由に色々試してみましょう。楽しめたらベストです。
 
-----------------
 1章はこれでおわりです。おつかれさまでした。[次の章](@next)へ進みましょう。
 
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
func design( screen:PGScreen ) {
    //#-editable-code
    screen.clearColor = .lightGrey
    
    PGRectangle()
    .color( .blue )
    .scale( width:200, height:200 )
    .position( cx: -100, cy:100 )
    .angle( degrees: 45.0 )
    .alpha( 0.5 )
    
    //#-end-editable-code
}

//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
