//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
/*:#localized( key:"--explain" )
# 2-10. 図形をランダムに
[ランダムな色・大きさ](2-9.playgroundpage) を改良し、さらに色々な形を描いてみましょう。

----------------- 
 1. 前回のコードに``let a = (0.0...3.0).randomize``を記述します。
 (0.0...3.0)と小数で指定します。得られるランダム値も小数となります。
 
 2. aの値でifの条件をつくり、3つの図形を描きわけます。
 ````
 func design( screen:PGScreen ) {
    for _ in 0 ..< 100 {
        let a = (0.0...3.0).randomize
        if a < 1.0 {
            PGCircle()
            .color( .random )
            .scale( square:(20...100).randomize )
            .position( screen.randomPoint )
        }
        else if a < 2.0 {
            PGTriangle()
            .color( .random )
            .scale( square:(20...100).randomize )
            .position( screen.randomPoint )
        }
        else {
            PGRectangle()
            .color( .random )
            .scale( square:(20...100).randomize )
            .position( screen.randomPoint )     
        }
    }
 }
 ```` 
 3. 「コードを実行」を押します。 

----------------- 
## 目標 
+ 画面上の不定な位置に色や大きさが様々な図形が描かれれば成功です。 [**結果の例**](glossary://result-1-2-10)
+ **(+1)** 「コードを実行」を何度か試してください。結果が変わります。
 
-----------------
 終わったら[次のページ](@next)へ進みます。

-----------------  
- Note:
　``(1.0...3.0)``は小数の範囲を示す形です。\
　``.randomize``をつけると、範囲内のランダムな小数を1つ得られます。
 
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
func design( screen:PGScreen ) {
    //#-editable-code
    
    
    
    
    //#-end-editable-code
}

//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
