//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(everything, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
/*:#localized( key:"--explain" )
# 2-2. 横に並べる
[前ページ](2-1.playgroundpage) で色々な図形を描きました。ここでは円を横に並べてみましょう。

----------------- 
 1. 繰り返し文(``for``文)を使って円を複数並べます。繰り返し回数を**7**にします。
 for文の中にPGCircle()を入れることで複数の円を描きます。

 2. ``.position(cx:`` で繰り返しのカウンタ``x``に70を掛けて加算します。
 ````
 func design( screen:PGScreen ) {
    for x in 0 ..< 7 {
        PGCircle()
        .color( .blue )
        .scale( width:50, height:50 )
        .position( cx:-210 + x * 70,
                   cy:0 )
    }
 }
 ```` 
 3. 「コードを実行」を押します。 

----------------- 
## 目標 
+ 横に並んだ円が表示されたら成功です。 [**結果の例**](glossary://result-1-2-2)
+ **(+1)** 繰り返し回数、また.positionでの掛け算の値を変えてみましょう。
+ **(+2)** 円をぼやけた円(PGBlurryCircle)などに変えてみましょう。
 
-----------------
 終わったら[次のページ](@next)へ進みます。
 
-----------------  
 - Note:
 **for x in 0 ..< 7 {**\
 　※ この中のコードを7回繰り返します。\
 　※ xの値が 0,1,2,3,...,6 と変化します。\
 **}**

 -----------------  
 - Note:
 for x in ... の``x``を**カウンタ**と呼びます。
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
func design( screen:PGScreen ) {
    for x in 0 ..< /*#-editable-code 繰り返し回数*/1/*#-end-editable-code*/ {
        PGCircle()
        .color( .blue )
        .scale( width:50, height:50 )
        .position( cx:/*#-editable-code 計算*/-210 + 0/*#-end-editable-code*/,
                   cy:/*#-editable-code 計算*/0/*#-end-editable-code*/ )
    }
}

//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
