//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
/*:#localized( key:"--explain" )
# 2-4. 図形を交互に並べる
[縦横に並べる](2-3.playgroundpage) を発展させて、複数の図形を描きます。

----------------- 
 1. 前ページのプログラムに``if``文を追加して、条件によって描く形を変えます。ここではxが偶数の時に円、奇数の時に三角を描くようにします。
 ````
 func design( screen:PGScreen ) {
    for y in 0 ..< 7 {
        for x in 0 ..< 7 {
            if x % 2 == 0 {
                PGCircle()
                .color( .blue )
                .scale( width:50, height:50 )
                .position( cx:-210 + x * 70,
                           cy:-210 + y * 70 )
            }
            else {
                PGTriangle()
                .color( .red )
                .scale( width:50, height:50 )
                .position( cx:-210 + x * 70,
                           cy:-210 + y * 70 )       
            }
        }
    }
 }
 ```` 
 2. 「コードを実行」を押します。 

----------------- 
## 目標 
+ 横方向に丸と三角が交互に表示されたら成功です。 [**結果の例**](glossary://result-1-2-4)
 
-----------------
 終わったら[次のページ](@next)へ進みます。

-----------------  
 - Note:
 **if 条件 {**\
 　※ 条件を満たしたときの処理\
 **}**\
 **else {**\
 　※ 条件を満たさなかったときの処理\
 **}**
 
 -----------------  
 - Note:
 **x % 2** は「xを2で割った余り」です。結果が0ならx=偶数、1ならx=奇数となります。
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
func design( screen:PGScreen ) {
    for y in 0 ..< /*#-editable-code 縦の繰り返し回数*/7/*#-end-editable-code*/ {
        for x in 0 ..< /*#-editable-code 横の繰り返し回数*/7/*#-end-editable-code*/ {
            if /*#-editable-code*/x % 2 == 0/*#-end-editable-code*/ {
                //#-editable-code
                PGCircle()
                .color( .blue )
                .scale( width:50, height:50 )
                .position( cx:-210 + x * 70,
                           cy:-210 + y * 70 )
                //#-end-editable-code
            }
            else {
                //#-editable-code
                
                
                
                
                
                //#-end-editable-code
            }
        }
    }
}

//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
