//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
/*:#localized( key:"--explain" )
# 2-5. 図形のチェッカー
[前回のプログラム](2-4.playgroundpage) の条件を工夫すると、チェッカー模様にできます。条件だけ変えてみましょう。

----------------- 
 1. 前ページのプログラムの``if``文の条件を変えます。条件には **(x + y) % 2 == 0** を入れます。
 ````
 func design( screen:PGScreen ) {
    for y in 0 ..< 7 {
        for x in 0 ..< 7 {
            if (x + y) % 2 == 0 {
                PGCircle()
                .color( .blue )
                .scale( width:50, height:50 )
                .position( cx:-210 + x * 70,
                           cy:-210 + y * 70 )
            }
            else {
                PGTriangle()
                .color( .red )
                .scale( width:50, height:50 )
                .position( cx:-210 + x * 70,
                           cy:-210 + y * 70 )       
            }
        }
    }
 }
 ```` 
 2. 「コードを実行」を押します。 

----------------- 
## 目標 
+ 色違いのパネルが表示されたら成功です。 [**結果の例**](glossary://result-1-2-5)
 
-----------------
 終わったら[次のページ](@next)へ進みます。

-----------------   
 - Note:
 **(x + y) % 2** は「xとyを足して、2で割った余り」です。この結果の偶数奇数で市松模様が表現できます。
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
func design( screen:PGScreen ) {
    for y in 0 ..< 7 {
        for x in 0 ..< 7 {
            if /*#-editable-code 条件*//*#-end-editable-code*/ {
                PGCircle()
                .color( .blue )
                .scale( width:50, height:50 )
                .position( cx:-210 + x * 70,
                           cy:-210 + y * 70 )
            }
            else {
                PGTriangle()
                .color( .red )
                .scale( width:50, height:50 )
                .position( cx:-210 + x * 70,
                           cy:-210 + y * 70 )       
            }
        }
    }
}

//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
