//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
/*:#localized( key:"--explain" )
# 2-7. フリーコード
ここまで[2-5の図形パターン](2-5.playgroundpage), [2-6の色パターン](2-6.playgroundpage) などを学んできました。おさらいとして、自由にコードを書いてみましょう。``for``や``if`｀を使って複数の図形をたくさん書いてみてください。

-----------------
 + 四角を描く:\
 `PGRectangle()`
 
 + 三角を描く:\
 `PGTriangle()`
 
 + 円を描く:\
 `PGCircle()`
 
 + ぼかし円を描く:\
 `PGBlurryCircle()`
 
 + 繰り返し処理:\
 `for a in 0 ..< 繰り返し回数 { 繰り返す処理 }`
 
 + 条件分岐:\
 `if 条件 { 条件を満たした時 }`\
 `else { 条件を満たさない時 }`
 
----------------- 
## 目標 
+ 色々な形を描いたり、繰り返し・条件分岐を使って楽しんでください。
 
-----------------
 終わったら[次のページ](@next)へ進みます。

*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
func design( screen:PGScreen ) {
    //#-editable-code
    // /*#-localizable-zone(comment2_7a)*/自由に書き換えてみてください/*#-end-localizable-zone*/
    for y in 0 ..< 7 {
        for x in 0 ..< 7 {
            PGCircle()
            .color( red: Double( x ) / 7.0,
                  green: Double( y ) / 7.0,
                   blue: Double( x + y ) / 14.0 )
            .scale( width:50, height:50 )
            .position( cx:-210 + x * 70,
                         cy:-210 + y * 70 )
    
    
        }
    }
    //#-end-editable-code
}

//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
