//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
/*:#localized( key:"--explain" )
# 3-2. マスクとして用いる
さて、[画像をそのまま表示](3-1.playgroundpage)しましたが、Lily Playgroundでは、画像をマスクに使うことが増えてきます。ここではマスク画像を使う方法を試してみましょう。画像をマスクにするときは``PGMask``をつかいます。また、もとの画像がどんなものであるかを見るために``PGPicture``でも表示してみましょう。
 
----------------- 
 1. ``PGPicture( "mask-star" )``を書きます。``.cx( -128 )``で左に移動させます。
 
 2. 次に``PGMask( "mask-star" )``を書きます。``.cx( 128 )``で右に移動させます。
 
 3. ``PGMask( "mask-star" )``に``.color( .blue )``を追加します。
 ````
 func design( screen:PGScreen ) {
    PGPicture( "mask-star" )
    .scale( square:128 )
    .cx( -128 )

    PGMask( "mask-star" )
    .scale( square:128 )
    .cx( 128 )
    .color( .blue )
 }
 ```` 
 4. 「コードを実行」を押します。 

----------------- 
## 目標 
+ 左に白黒の星マーク、右に星マークの白い部分に青になった透けた星が描けたら成功です。 [**結果の例**](glossary://result-1-3-2)

-----------------
 終わったら[次のページ](@next)へ進みます。

-----------------
- Note:
 PGMaskは画像の黒部分を透かして、白部分の形を描きます。色は``.color``で指定できます。画像の灰色部分は灰色の濃さに合わせて半透明になります。
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
func design( screen:PGScreen ) {
    //#-editable-code
    PGPicture( "mask-star" )
    .scale( square:128 )
    
    
    //#-end-editable-code
}

//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
