//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
/*:#localized( key:"--explain" )
# 3-4. マスクを重ねる表現
[マスク用画像の紹介](3-3.playgroundpage)を試しました。マスクを使った図形を重ねるていくと豊かで複雑な表現が可能になります。

ここではスモーク画像を重ねて絵を作ってみます。
 
----------------- 
 1. 背景色は``screen.clearColor = .darkGrey``を指定します。

 2. ``PGMask( "mask-smoke" )`` をforループで50個重ねてみましょう。
 
 3. ``.position``、``.scale``、``.alpha``、``.angle`` をつかって以下のようにランダムな値を指定します。
 ````
 func design( screen:PGScreen ) {
    screen.clearColor = .darkGrey

    for _ in 0 ..< 50 {
        PGMask( "mask-smoke" )
        .scale( square:(16...192).randomize )
        .position( cx:(-128...128).randomize,
                   cy:(-128...128).randomize )
        .alpha( .random )
        .angle( .random )
        .color( .white )
    }
 }
 ```` 
 4. 「コードを実行」を押します。 

----------------- 
## 目標 
+ 煙が重なっているような表現ができたら成功です。 [**結果の例**](glossary://result-1-3-4)
 
+ **(+1)** 何回かコード実行をしてみてください。色々な形の煙ができます。

-----------------
 3章はこれでおわりです。おつかれさまでした。[次の章](@next)へ進みましょう。

*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
func design( screen:PGScreen ) {
    //#-editable-code
    screen.clearColor = .darkGrey
    
    
    
    
    //#-end-editable-code
}

//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
