//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
/*:#localized( key:"--explain" )
# 4-1. 重ねて模様をつくる
[前章](3.playgroundchapter/3-4.playgroundpage) まで、Lily Playgroundでの図形や画像の描き方を紹介しました。この章は、ここまで学んだ図形を並べて、模様を作っていきたいと思います。きれいな模様を描いていきましょう。
 
----------------- 
 1. x,yの2重のfor文をつくり、その中で円が規則的に並ぶようにコードを書きます。
 
 2. 円の色を交互に変えるように、条件分岐で色を変化させましょう。**変数**``var c``をつくります。``c``には色(``LLColor.clear``)を入れます。
 
 3. [チェッカー](2.playgroundchapter/2-5.playgroundpage)の条件にならって、``c``の値を変えてみましょう。条件ごとにオレンジ色( 1.0, 0.5, 0.0, 1.0 )と、明るい緑色( 0.2, 0.8, 0.2, 1.0 ) を``c``に入れます。
 
 4. ``c`` を円の ``.color`` に使います。すると 「``c`` の色が変わる = 円の色が変わる」ことになります。手順3の条件で ``c``の色は互い違いになったので、円の色も互い違いにできます。
 
 ````
 func design( screen:PGScreen ) {
    for y in 0 ..< 9 {
        for x in 0 ..< 9 {
            var c = LLColor.clear

            if (x + y) % 2 == 0 {
                c = LLColor( 1.0, 0.5, 0.0, 1.0 )
            }
            else {
                c = LLColor( 0.2, 0.8, 0.2, 1.0 )
            } 

            PGCircle()
            .scale( square:100 )
            .position( cx: -200 + x * 50,
                       cy: -200 + y * 50 ) 
            .color( c )
            .alpha( 0.33 )
        }
    }
 }
 ```` 
 5. 「コードを実行」を押します。 

----------------- 
## 目標 
+ 重ねた円による模様が表現できたら成功です。 [**結果の例**](glossary://result-1-4-1)

-----------------
 終わったら[次のページ](@next)へ進みます。
 
-----------------
 - Note:
 ``LLColor``は**色値**です。順に **red, green, blue, alpha** の4つの値を指定してください。

-----------------
 - Note:
 ``var c``は**変数**で、``c``は**変数名**と呼びます。決めた形式の値を格納できます。今回は始めにLLColor.clearを入れたため、LLColor格納用の変数``c``となります。

*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
func design( screen:PGScreen ) {
    //#-editable-code
    
    
    
    
    
    
    
    //#-end-editable-code
}

//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
