//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
/*:#localized( key:"--explain" )
# 4-2. 加算合成

[前回](4-1.playgroundpage) まで学んできた図形に「重ねたときの効果」を加えて、さらに表現の幅を広げます。効果はわかりやすくシンプルです。メジャーなものが「加算合成」です。加算合成は重なった色が明るくなっていきます。

![通常合成と加算合成の例](lilypg1-4-1-addcircle.png)
 
 まずは上の図と同じ結果を得られるようコードを書いてみましょう。
 
----------------- 
 1. 通常の円を2つ描きます。
 
 2. 次に加算合成の円を2つ描きます。加算合成円は ``PGAddCircle()`` を使います。
 
 3. 赤のPGCircle()に``.zIndex( 1 )``, 青のPGCircle()に``.zIndex( 2 )``を追加します。zIndexは重なり順をコントロールできます。数字が大きい方が上になります。
 ````
 func design( screen:PGScreen ) {
    screen.clearColor = .darkGrey

    PGCircle()
    .scale( square:200 )
    .position( cx: -50, cy: 150 ) 
    .color( .red )
    .zIndex( 1 )

    PGCircle()
    .scale( square:200 )
    .position( cx: 50, cy: 150 ) 
    .color( .blue )
    .zIndex( 2 )

    PGAddCircle()
    .scale( square:200 )
    .position( cx: -50, cy: -150 ) 
    .color( .red )

    PGAddCircle()
    .scale( square:200 )
    .position( cx: 50, cy: -150 ) 
    .color( .blue )
 }
 ```` 
 4. 「コードを実行」を押します。 

----------------- 
## 目標 
+ 通常の重なる円と、加算合成で重なった円が表示されれば成功です。加算合成の色を観察してください。背景の色も含めて、重なると明るい色に向かっていくことがわかります。 [**結果の例**](glossary://result-1-4-2)

-----------------
 終わったら[次のページ](@next)へ進みます。
 
-----------------
 - Note:
 加算合成は重ねると白に近づきます。白の背景に描いても効果がないので、サンプルでは``screen.clearColor = .darkGrey``を用いています。
 
-----------------
 - Note: 
 zIndexの初期値は0.0です。0.0~99999.0までの小数を指定できます。
 
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
func design( screen:PGScreen ) {
    //#-editable-code
    screen.clearColor = .darkGrey
    
    
    //#-end-editable-code
}

//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
