//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
/*:#localized( key:"--explain" )
# 4-3. 合成で模様を描く
 
[加算合成](4-2.playgroundpage) をつかって、模様を描いてみましょう。

----------------- 
 1. 背景色を ``screen.clearColor = .darkGrey`` にします。
 
 2. [4-1の模様](4-1.playgroundpage)のコードを参考に、``PGCircle()``の部分を、加算合成の円 ``PGAddCircle()`` に変えてみます。
 ````
 func design( screen:PGScreen ) {
    // 背景の色
    screen.clearColor = .darkGrey

    for y in 0 ..< 9 {
        for x in 0 ..< 9 {
            var c = LLColor.clear

            if (x + y) % 2 == 0 {
                c = LLColor( 1.0, 0.5, 0.0, 1.0 )
            }
            else {
                c = LLColor( 0.2, 0.8, 0.2, 1.0 )
            } 

            PGAddCircle()
            .scale( square:100 )
            .position( cx: -200 + x * 50,
                       cy: -200 + y * 50 ) 
            .color( c )
            .alpha( 0.33 )
        }
    }
 }
 ```` 
 3. 「コードを実行」を押します。 

----------------- 
## 目標 
+ 重なった部分が明るくなっている円の模様が表示されたら成功です。 [**結果の例**](glossary://result-1-4-3)
 
+ **(+1)** ``.color`` や ``.scale``、``.position`` の値を変更し、模様の雰囲気を変えてみましょう。

-----------------
 終わったら[次のページ](@next)へ進みます。
 
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
func design( screen:PGScreen ) {
    //#-editable-code
    // 背景の色
    screen.clearColor = .darkGrey
    
    
    
    
    //#-end-editable-code
}

//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
