//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
/*:#localized( key:"--explain" )
# 4-6. マスク画像できらめき
 
加算合成はマスク画像 ( ``PGAddMask( "画像名" )`` ) でも使えます。マスク画像を合成で重ね合わせると綺麗な模様が描けます。ここではmask-sparkle.pngを使ってきらめきのある模様を描いてみましょう。

----------------- 
 1. 背景色を ``screen.clearColor = .darkGrey`` にします。
 
 2. ``PGAddMask( "mask-sparkle" )``をランダムに描画します。
 
 3. ``.color`` と ``.alpha``は値の範囲を0.5~1.0のランダムになるようにします。
 ````
 func design( screen:PGScreen ) {
    // 背景の色
    screen.clearColor = .darkGrey

    for _ in 0 ..< 100 {
        PGAddMask( "mask-sparkle" )
        .color( red:(0.5...1.0).randomize,
              green:(0.5...1.0).randomize,
               blue:(0.5...1.0).randomize
          )
        .scale( square:(40...160).randomize )
        .position( screen.randomPoint )
        .alpha( (0.5...1.0).randomize )
    }
 }
 ```` 
 4. 「コードを実行」を押します。 

----------------- 
## 目標 
+ きらめきの模様が描ければ成功です。 [**結果の例**](glossary://result-1-4-6)
 
-----------------
 終わったら[次のページ](@next)へ進みます。
 
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
func design( screen:PGScreen ) {
    //#-editable-code
    // 背景の色
    screen.clearColor = .darkGrey
    
    
    
    
    
    
    //#-end-editable-code
}

//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
