//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
/*:#localized( key:"--explain" )
# 4-7. 光る熱源表現

さあこのBookの仕上げです。 [前回](4-6.playgroundpage) できらめき表現をしました。マスク画像を変えたり、値を変えることで色々な表現ができます。mask-smoke.png画像を使って、光る熱源を表現してみましょう。

----------------- 
 1. 背景色を ``screen.clearColor = .darkGrey`` にします。
 
 2. ``PGAddMask( "mask-smoke" )``をランダムに50個描画します。
 
 3. 発生位置を円形の中に収める、x, yを計算します。計算は下記のサンプルの``let dist``、 ``let vector``、 ``let x``、 ``let y`` の内容を真似てください。
 ````
 func design( screen:PGScreen ) {
    // 背景の色
    screen.clearColor = .darkGrey

    for _ in 0 ..< 200 {
        let dist = (0.0...200.0).randomize
        let vector = (-2.0...2.0).randomize * 3.14
        let x = dist * cos( vector )
        let y = dist * sin( vector )

        PGAddMask( "mask-smoke" )
        .color( red:0.15, green: 0.2, blue:0.5 )
        .scale( square:(100...200).randomize )
        .position( cx:x, cy:y )
        .angle( .random )
        .alpha( .random )
    }
 }
 ```` 
 4. 「コードを実行」を押します。 

----------------- 
## 目標 
+ 青く光る熱源のようなモヤが表現できたら成功です。 [**結果の例**](glossary://result-1-4-7)
 
+ **(+1)** ``.color``の値をredが強いもの、greenが強いものなどに変えてみましょう。
 
-----------------
 終わったら[次のページ](@next)へ進みます。
 
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
func design( screen:PGScreen ) {
    //#-editable-code
    // 背景の色
    screen.clearColor = .darkGrey
    
    
    
    
    //#-end-editable-code
}

//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
