//
// LilySwift Library Project
//
// Copyright (c) Watanabe-Denki Inc. and Kengo Watanabe.
//   https://wdkk.co.jp/
//
// This software is released under the MIT License.
//   https://opensource.org/licenses/mit-license.php
//

import UIKit
import PlaygroundSupport
import LilySwiftForPlayground

public func setupPG() -> PGScreen
{
    let device = MTLCreateSystemDefaultDevice()!
    
    let planeStorage:PlaneStorage = .init(
        device: device,
        capacity: 2000, 
        textures: ["lily", "mask-sparkle", "mask-snow", "mask-smoke", "mask-star"]
    )
    
    let vc = PGScreen( 
        device:device,
        environment:.string,
        planeStorage:planeStorage
    )
    
    PlaygroundPage.current.liveView = vc
    
    return vc
}
