//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
/*:#localized( key:"--explain" )
# 1-1. 位置のアニメート
このBookでは、**LilyPlayground**で描いた図形を動かすプログラミングを学びます。
工夫をこらして、美しいアニメーションをつくっていきましょう。

LilyPlaygroundでは、1秒間に最大60回、画面をリフレッシュします。その1回ごとに図形のパラメータを変えることで、動きを表現します。
1回ごとに加算する値を ``delta`` と呼びます。たとえば、 ``position`` の加算値は ``deltaPosition`` です。

てはじめに ``deltaPosition`` を使ってみましょう。

-----------------
 1. design関数内に、 ``PGCircle()`` を書きます。
 
 2. PGCircleに ``.deltaPosition(dx:dy:)`` を追加します。
 ````
 func design( screen:PGScreen ) {
    PGCircle()
    .deltaPosition( dx:0.5, dy:1.0 )
 }
 ````
 3. 「コードを実行」を押します。
 
-----------------
## 目標
+ 中心から右上に移動する円が出たら成功です。 [**結果の例**](glossary://result-2-1-1)
 
-----------------
終わったら[次のページ](@next)へ進みます。
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-editable-code
func design( screen:PGScreen ) {
    PGCircle()
    
}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
