//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, deltaScale, deltaScale(dw:dh:) )
//#-code-completion(identifier, show, deltaColor, deltaColor(red:green:blue:) )
//#-code-completion(identifier, show, deltaAngle, deltaAngle(red:green:blue:) )
//#-code-completion(identifier, show, deltaAlpha, deltaAlpha() )
//#-code-completion(identifier, show, interval, interval(sec:) )
//#-code-completion(identifier, show, completion, completion() )
//#-code-completion(identifier, show, life, life() )
//#-code-completion(identifier, show, deltaLife, deltaLife() )
/*:#localized( key:"--explain" )
# 1-10. 図形の再利用

[前ページ](@previous)では ``life`` がなくなった時の処理、 ``.completion{ }`` を紹介しました。
ここでは ``.completion{ }`` を活用して、図形を再利用してアニメーションを繰り返してみましょう。
 
-----------------
 1. ``PGCircle()`` を書きます。

 2. フレームごとの移動量 ``.deltaPosition( dx:0.0, dy:-1.0 )`` を指定します。
 
 3. 初期ライフとして ``.life( 1.0 )`` を指定します。またlifeに合わせて ``.alpha( 1.0 )`` を指定します。

 4. フレームごとの減り量として、 ``.deltaLife( -0.01 )`` と ``deltaAlpha( -0.01 )`` を指定します。
 
 5. ``.completion`` のブロック内で図形を再設定します。 ``.position()``, ``.life()``, ``.alpha()`` を使って、それぞれ初期化します。
 
 6. フレーバーとして ``.color( .random )`` を追加します。
 ````
 func design( screen:PGScreen ) {
    PGCircle()
    .deltaPosition( dx:0.0, dy:-1.0 )
    .life( 1.0 )
    .deltaLife( -0.01 )
    .alpha( 1.0 )
    .deltaAlpha( -0.01 )
    .completion {
        $0
        .position( cx:0, cy:0 )
        .life( 1.0 )
        .alpha( 1.0 )
        .color( .random )
    }
 }
 ````
 7. 「コードを実行」を押します。
 
-----------------
## 目標
+ 円が下に移動しながら消えます。円が消えたあと、中央から異なる色の円が再度現れ、繰り返しアニメーションすれば成功です。 [**結果の例**](glossary://result-2-1-10)
 
-----------------
終わったら[次のページ](@next)へ進みます。

-----------------  
- Note:
``.completion`` は ``interval`` 同様にクロージャ関数を指定します。図形の ``life`` が0になった時に一度だけクロージャが実行されます。``$0`` は呼び出している図形自身です( ``inteval`` と同様です)。ただしこの ``completion`` 内で、再度lifeが0.0より大きな値となった場合、図形は削除されないようになります。
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-editable-code
func design( screen:PGScreen ) {
    PGCircle()
    
}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
