//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, deltaScale, deltaScale(dw:dh:) )
//#-code-completion(identifier, show, deltaColor, deltaColor(red:green:blue:) )
//#-code-completion(identifier, show, deltaAngle, deltaAngle(red:green:blue:) )
//#-code-completion(identifier, show, deltaAlpha, deltaAlpha() )
//#-code-completion(identifier, show, interval, interval(sec:) )
//#-code-completion(identifier, show, completion, completion(), completion{} )
//#-code-completion(identifier, show, life, life() )
//#-code-completion(identifier, show, deltaLife, deltaLife() )
//#-code-completion(identifier, show, iterate, iterate(), iterate{} )
/*:#localized( key:"--explain" )
# 1-11. 毎フレームの処理

[前ページ](@previous)で終了時の操作を学びました。
ここでは、毎フレームの処理を自分で書いてみましょう。
 
-----------------
 1. ``PGCircle()`` を書きます。

 2. ``.position(cx:cy:)``, ``deltaPosition(dx:dy:)``, ``.life()``, ``deltaLife()`` を指定します。はじめの初期化です。
 
 3. ``.completion{ }`` で再利用を行います。 ``.position(cx:cy:)``、``deltaPosition(dx:dy:)``, ``.life()`` をそれぞれ元の値に戻します。 ``.color()``　は[前回](@previous)と同じくランダムにします。
 
 4. 続けて ``.iterate{ }`` を書きます。そのブロック内で ``$0.deltaPosition(dx:dy:)`` を書きます。deltaPosition.yの値を1.08倍します。
 ````
 func design( screen:PGScreen ) {
    PGCircle()
    .position( cx:0.0, cy:200.0 )
    .deltaPosition( dx:0.0, dy:-1.0 )
    .life( 1.0 )
    .deltaLife( -0.01 )
    .completion {
        $0
        .position( cx:0.0, cy:200.0 )
        .deltaPosition( dx:0.0, dy:-1.0 )
        .life( 1.0 )
        .color( .random )
    }
    .iterate {
        $0
        .deltaPosition( 
            dx: 0.0,
            dy: $0.deltaPosition.y * 1.08 )
    }
 }
 ````
 5. 「コードを実行」を押します。
 
-----------------
## 目標
+ 円が少しずつ加速して落ちるアニメーションが繰り返されれば成功です [**結果の例**](glossary://result-2-1-11)
 
-----------------
終わったら[次のページ](@next)へ進みます。
 
 -----------------  
 - Note:
 ``.iterate{ }`` のブロックは、毎フレーム(1秒間に60回)呼ばれます。今回は ``deltaPosition.y`` を毎回1.08倍しているので、1フレームごとに速度が速くなります。
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-editable-code
func design( screen:PGScreen ) {
    PGCircle()
    .position( cx:0.0, cy:200.0 )
    .deltaPosition( dx:0.0, dy:-1.0 )
    .life( 1.0 )
    .deltaLife( -0.01 )
    .completion {
        $0
        .position( cx:0.0, cy:200.0 )
        .deltaPosition( dx:0.0, dy:-1.0 )
        .life( 1.0 )
        .color( .random )
    }
    
    
}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
