//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, deltaScale, deltaScale(dw:dh:) )
//#-code-completion(identifier, show, deltaColor, deltaColor(red:green:blue:) )
//#-code-completion(identifier, show, deltaAngle, deltaAngle(red:green:blue:) )
//#-code-completion(identifier, show, deltaAlpha, deltaAlpha() )
/*:#localized( key:"--explain" )
# 1-6. 組み合わせる

[前ページ](@previous)までのアニメーションを組み合わせてみましょう。
 
-----------------
 1. 四角``PGRectangle()`` を使います。
 
 2. 続けて ``.deltaPosition(dx:dy:)``, ``.deltaScale(dw:dh:)``, ``.deltaColor(red:green:blue:)``,  ``.deltaAngle(degrees:)``, ``.deltaAlpha()`` を追加して、以下の例のように書きます。
 
 ````
 func design( screen:PGScreen ) {
    PGRectangle()
    .deltaPosition( dx:0.2, dy:0.5 )
    .deltaScale( dw:0.4, dh:-0.1 )
    .deltaColor( red:0.002,
               green:0.003,
                blue:0.001 )
    .deltaAngle( degrees:2.0 )
    .deltaAlpha( -0.002 )
 }
 ````
 2. 「コードを実行」を押します。
 
-----------------
## 目標
+ 形、位置、色を変えながら消えていく四角が表示されたら成功です。 [**結果の例**](glossary://result-2-1-6)
 
-----------------
終わったら[次のページ](@next)へ進みます。
 
 -----------------  
 - Note:
ここまでで取り扱った``delta``シリーズの関数は初期値は**0**です。0であるため、フレームが進んでも値は変化しません。
 
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-editable-code
func design( screen:PGScreen ) {
    PGRectangle()
    
}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
