//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, deltaScale, deltaScale(dw:dh:) )
//#-code-completion(identifier, show, deltaColor, deltaColor(red:green:blue:) )
//#-code-completion(identifier, show, deltaAngle, deltaAngle(red:green:blue:) )
//#-code-completion(identifier, show, deltaAlpha, deltaAlpha() )
//#-code-completion(identifier, show, interval, interval(sec:) )
/*:#localized( key:"--explain" )
# 1-7. 一定間隔で実行する

[前ページ](@previous)までに、基本的なdeltaの使い方を紹介しました。ここでは一定間隔で実行する処理を紹介します。
 
-----------------
 1. 四角  ``PGRectangle()`` を使います。サイズは ``.scale( square:200 )`` を指定して大きめにします（見やすくするためです）。
 
 2. ``.deltaAngle(degrees:)`` を追加し、回転させます。
 
 3. ``.inteval(sec:)`` を追加し、続けて ``{ }`` で処理ブロックを書きます。
 
 4. 作った処理ブロックの中に ``$0`` と、続けて ``.color( .random )`` を書きます。
 ````
 func design( screen:PGScreen ) {
    PGRectangle()
    .scale( square:200 )
    .deltaAngle( degrees:1.0 )
    .interval( sec:1.0 ) {
        $0
        .color( .random )
    }
 }
 ````
 5. 「コードを実行」を押します。
 
-----------------
## 目標
+ 回転しながら、1秒ごとに色がランダムに変化する四角が表示されたら成功です。 [**結果の例**](glossary://result-2-1-7)
 
-----------------
終わったら[次のページ](@next)へ進みます。
 
-----------------  
- Note:
``.interval(sec:)`` の後ろの処理ブロックは**クロージャ**と呼ばれる関数です。intervalがsecで指定した秒数ごとに、クロージャを繰り返して処理します。

-----------------  
- Note:
``$0`` はSwiftの省略表記です。**クロージャに渡される最初の値**という意味になります。渡されるものは処理によって変わります。 ``.interval(sec:)`` の場合、 ``$0`` はintervalを呼んでいる**図形自身**です。
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-editable-code
func design( screen:PGScreen ) {
    PGRectangle()
    
}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
