//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, deltaScale, deltaScale(dw:dh:) )
//#-code-completion(identifier, show, deltaColor, deltaColor(red:green:blue:) )
//#-code-completion(identifier, show, deltaAngle, deltaAngle(red:green:blue:) )
//#-code-completion(identifier, show, deltaAlpha, deltaAlpha() )
//#-code-completion(identifier, show, interval, interval(sec:) )
//#-code-completion(identifier, show, completion, completion() )
//#-code-completion(identifier, show, life, life() )
//#-code-completion(identifier, show, deltaLife, deltaLife() )
/*:#localized( key:"--explain" )
# 1-9. 終了処理とライフの復活

[前ページ](@previous)で、 ``life`` を紹介しました。
 ``life`` が0.0になった時、図形が消える前の終了処理を行えます。 ``.completion{ }`` を使ってみましょう。
 
-----------------
 1. ``PGCircle()`` を書きます。
 
 2. 初期ライフとして ``.life( 1.0 )`` を指定します。またlifeに合わせて ``.alpha( 1.0 )`` を指定します。
 
 3. フレームごとの減り量として、 ``.deltaLife( -0.005 )`` と ``deltaAlpha( -0.005 )`` を指定します。
 
 4. ``.completion`` のブロック内で ``$0`` と、続けて ``.life( 1.0 )`` を指定して1.0に戻します。 アルファ値も ``.alpha( 1.0 )`` で戻します。
 ````
 func design( screen:PGScreen ) {
    PGCircle()
    .life( 1.0 )
    .deltaLife( -0.005 )
    .alpha( 1.0 )
    .deltaAlpha( -0.005 )
    .completion {
        $0
        .life( 1.0 )
        .alpha( 1.0 )
    }
 }
 ````
 4. 「コードを実行」を押します。
 
-----------------
## 目標
+ 円が表示されたあと、3~4秒待って円が消え、また表示されるのを繰り返したら成功です。 [**結果の例**](glossary://result-2-1-9)
 
-----------------
終わったら[次のページ](@next)へ進みます。

-----------------  
- Note:
``.completion``は``interval``同様にクロージャ関数を指定します。図形の``life``が0になった時に一度だけクロージャが実行されます。``$0``は呼び出している図形自身です(``inteval``と同様です)。ただしこの``completion``内で再度lifeが0.0より大きな値となった場合、図形は削除されないようになります。
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-editable-code
func design( screen:PGScreen ) {
    PGCircle()
    
}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
