//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, PGRectangle )identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, deltaScale, deltaScale(dw:dh:) )
//#-code-completion(identifier, show, deltaColor, deltaColor(red:green:blue:) )
//#-code-completion(identifier, show, deltaAngle, deltaAngle(red:green:blue:) )
//#-code-completion(identifier, show, deltaAlpha, deltaAlpha() )
//#-code-completion(identifier, show, interval, interval(sec:) )
//#-code-completion(identifier, show, completion, completion(), completion{} )
//#-code-completion(identifier, show, life, life() )
//#-code-completion(identifier, show, deltaLife, deltaLife() )
//#-code-completion(identifier, show, iterate, iterate(), iterate{} )
/*:#localized( key:"--explain" )
# 2-6. どんどん大きく

[前ページ](@previous)で、``iterate{ }`` を使って四角を加速させる表現を作りました。
 
合わせて、スケーリング変化も加速させて、迫ってくる四角を表現しましょう。

-----------------
 1. [前ページ](@previous)と同じコードを書きます。
 
 2. ``.completion{ }``内の ``$0`` に ``.deltaScale(dx:dy:)`` を追加します。値は **dw:1.0, dh:1.0** を指定します。

 3. ``.iterate{ }`` 内の ``$0`` に ``.deltaScale(dw:dh:)`` を追加します。``deltaScale.width`` と ``deltaScale.height`` を**1.02倍**した値を設定します。1フレームごとに拡大量が増えていきます。
 ````
 func design( screen:PGScreen ) {
    for _ in 0 ..< 20 {
        PGRectangle()
        .position( screen.randomPoint )
        .deltaPosition(
            dx:(-1.0...1.0).randomize,
            dy:(-1.0...1.0).randomize
        )
        .scale( square: 0.0 )
        .deltaScale( dw:1.0, dh:1.0 )
        .angle( .random )
        .deltaAngle( degrees:1.0 )
        .color( .random )
        .life( .random )
        .deltaLife( -0.005 )
        .completion {
            $0
            .position( screen.randomPoint )
            .deltaPosition( 
                dx:(-1.0...1.0).randomize,
                dy:(-1.0...1.0).randomize 
            )
            .scale( square: 0.0 )
            .deltaScale( dw:1.0, dh:1.0 )
            .angle( .random )
            .color( .random )
            .life( 1.0 )
        }
        .iterate {
            $0
            .alpha( $0.life )
            .deltaPosition( 
              dx:$0.deltaPosition.x * 1.04,
              dy:$0.deltaPosition.y * 1.04
            )
            .deltaScale(
              dw:$0.deltaScale.width * 1.02,
              dh:$0.deltaScale.height * 1.02
            )
        }
    }
 }
 ````
 4. 「コードを実行」を押します。
 
-----------------
## 目標
+ 四角がだんだん加速して迫ってくる動きが描けたら成功です。 [**結果の例**](glossary://result-2-2-6)
 
-----------------
終わったら[次のページ](@next)へ進みます。
 
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-editable-code
func design( screen:PGScreen ) {
    for _ in 0 ..< 20 {
        PGRectangle()
        .position( screen.randomPoint )
        .deltaPosition(
            dx:(-1.0...1.0).randomize,
            dy:(-1.0...1.0).randomize
        )
        .scale( square: 0.0 )
        .deltaScale( dw:1.0, dh:1.0 )
        .angle( .random )
        .deltaAngle( degrees:1.0 )
        .color( .random )
        .life( .random )
        .deltaLife( -0.005 )
        .completion {
            $0
            .position( screen.randomPoint )
            .deltaPosition( 
                dx:(-1.0...1.0).randomize,
                dy:(-1.0...1.0).randomize 
            )
            .scale( square: 0.0 )
            .angle( .random )
            .color( .random )
            .life( 1.0 )
        }
        .iterate {
            $0
            .alpha( $0.life )
            .deltaPosition( 
              dx:$0.deltaPosition.x * 1.04,
              dy:$0.deltaPosition.y * 1.04
            )
        }
    }
}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
