//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, PGRectangle )identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, deltaScale, deltaScale(dw:dh:) )
//#-code-completion(identifier, show, deltaColor, deltaColor(red:green:blue:) )
//#-code-completion(identifier, show, deltaAngle, deltaAngle(red:green:blue:) )
//#-code-completion(identifier, show, deltaAlpha, deltaAlpha() )
//#-code-completion(identifier, show, interval, interval(sec:) )
//#-code-completion(identifier, show, completion, completion(), completion{} )
//#-code-completion(identifier, show, life, life() )
//#-code-completion(identifier, show, deltaLife, deltaLife() )
//#-code-completion(identifier, show, iterate, iterate(), iterate{} )
/*:#localized( key:"--explain" )
# 2-7. 複数図形で視覚表現

[前ページ](@previous)で、四角が迫ってくるアニメーションを表現しました。このように基本動作を組み合わせて、さまざまな表現が可能です。
この章の締めくくりに、四角以外の形状も混ぜてみる例を紹介します。

-----------------
 1. 図形オブジェクトを入れる ``let shape:PGActor!`` を書きます。

 2. ``shape`` の形を決めるため、ランダム値 ``let rnd`` を作成します。
 
 
 3. ``rnd``の値を使って、 ``if``、``else if``、``else`` の条件分岐を書きます。条件によって ``shape`` に異なる形(円、四角、三角)を作成して、格納します。
 
 4. [前ページ](@previous)と同じ動作のコードを ``shape`` に対して記述します。
 ````
 func design( screen:PGScreen ) {
    for _ in 0 ..< 20 {
        let shape:PGActor!
        let rnd = (0.0...3.0).randomize
 
        if rnd < 1.0 {
           shape = PGRectangle()
        }
        else if rnd < 2.0 {
           shape = PGTriangle()
        }
        else {
           shape = PGCircle()
        }
         
        shape
        .position( screen.randomPoint )
        .deltaPosition(
            dx:(-1.0...1.0).randomize,
            dy:(-1.0...1.0).randomize
        )
        .scale( square: 0.0 )
        .deltaScale( dw:1.0, dh:1.0 )
        .angle( .random )
        .deltaAngle( degrees:1.0 )
        .color( .random )
        .life( .random )
        .deltaLife( -0.005 )
        .completion {
            $0
            .position( screen.randomPoint )
            .deltaPosition( 
                dx:(-1.0...1.0).randomize,
                dy:(-1.0...1.0).randomize 
            )
            .scale( square: 0.0 )
            .deltaScale( dw:1.0, dh:1.0 )
            .angle( .random )
            .color( .random )
            .life( 1.0 )
        }
        .iterate {
            $0
            .alpha( $0.life )
            .deltaPosition( 
              dx:$0.deltaPosition.x * 1.04,
              dy:$0.deltaPosition.y * 1.04
            )
            .deltaScale(
              dw:$0.deltaScale.width * 1.02,
              dh:$0.deltaScale.height * 1.02
            )
        }
    }
 }
 ````
 5. 「コードを実行」を押します。
 
-----------------
## 目標
+ 四角・丸・三角が加速して迫ってくる動きが描けたら成功です。 [**結果の例**](glossary://result-2-2-7)
 
-----------------
終わったら[次のページ](@next)へ進みます。
 
 -----------------  
 - Note:
 ``let shape:PGActor!`` は、PGActorオブジェクトを格納する定数です。中身はありません。
 ``!`` は**オプショナル**といいます。中身がない可能性のあるオブジェクトをつくります。
 後から色々な形を入れるため、この仕組みを使っています。

 -----------------  
 - Note:
 ``PGActor`` は**プロトコル**という仕組みです。 ``PGRectangle``、 ``PGCircle``、 ``PGTriangle`` の3つの図形は、 ``PGActor``プロトコルを使用しています。そのため、PGActorオブジェクトの定数に格納することができます。

*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-editable-code
func design( screen:PGScreen ) {
    for _ in 0 ..< 20 {
        
    
        
        
        
        
        
        shape
        .position( screen.randomPoint )
        .deltaPosition(
            dx:(-1.0...1.0).randomize,
            dy:(-1.0...1.0).randomize
        )
        .scale( square: 0.0 )
        .deltaScale( dw:1.0, dh:1.0 )
        .angle( .random )
        .deltaAngle( degrees:1.0 )
        .color( .random )
        .life( .random )
        .deltaLife( -0.005 )
        .completion {
            $0
            .position( screen.randomPoint )
            .deltaPosition( 
                dx:(-1.0...1.0).randomize,
                dy:(-1.0...1.0).randomize 
            )
            .scale( square: 0.0 )
            .deltaScale( dw:1.0, dh:1.0 )
            .angle( .random )
            .color( .random )
            .life( 1.0 )
        }
        .iterate {
            $0
            .alpha( $0.life )
            .deltaPosition( 
                dx:$0.deltaPosition.x * 1.04,
                dy:$0.deltaPosition.y * 1.04
            )
            .deltaScale(
                dw:$0.deltaScale.width * 1.02,
                dh:$0.deltaScale.height * 1.02
            )
        }
    }
}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
