//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, PGRectangle )identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, screen, minX, maxX, minY, maxY )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, deltaScale, deltaScale(dw:dh:) )
//#-code-completion(identifier, show, deltaColor, deltaColor(red:green:blue:) )
//#-code-completion(identifier, show, deltaAngle, deltaAngle(red:green:blue:) )
//#-code-completion(identifier, show, deltaAlpha, deltaAlpha() )
//#-code-completion(identifier, show, interval, interval(sec:) )
//#-code-completion(identifier, show, completion, completion(), completion{} )
//#-code-completion(identifier, show, life, life() )
//#-code-completion(identifier, show, deltaLife, deltaLife() )
//#-code-completion(identifier, show, iterate, iterate(), iterate{} )
/*:#localized( key:"--explain" )
# 3-1. キラキラ輝く

[前の章](@previous)までで、エフェクトのアニメーションの基礎を学びました。

この章では、これまでの学習内容を活かして、豊かな視覚表現をいくつか作っていきましょう。

まずはキラキラ輝く演出を作ってみます。

 ````
 func design( screen:PGScreen ) {
    screen.clearColor = .darkGrey
     
    for _ in 0 ..< 50 {
        PGAddMask( "mask-sparkle" )
        .color( .white )
        .position( screen.randomPoint )
        .scale( square: 15 )
        .deltaScale( dw:0.4, dh:0.4 )
        .angle( degrees: 0 )
        .deltaAngle( degrees: 0.5 )
        .alpha( 0 )
        .life( .random )
        .deltaLife( -0.01 )
        .iterate {
           if $0.life < 0.5 {
              $0.alpha( $0.life * 2.0 )
              
           }
           else {
              $0.alpha( (1.0 - $0.life) * 2.0 )
           }
        }     
        .completion {
            $0
            .position( screen.randomPoint )
            .scale( square:15 )
            .angle( degrees:0 )
            .alpha( 0 )
            .life( 1.0 )
        }
    }
 }
 ````
-----------------
 1. ``screen.clearColor = .darkGrey`` で背景を暗灰色にします。
 
----
 2. ``for``で50個の加算合成マスク画像 ``PGAddMask()`` を書きます。 画像ファイルは**mask-sparkle.png**を指定します。

----
 3. 初期設定のコードを書きます。
    - ``.color( .white )``
      - 色。白を設定します。
    - ``.position( screen.randomPoint )``
      - 位置。画面内のランダム座標を設定します。
    - ``.scale( square:15 )``
      - 大きさ。縦横15ポイントを設定します。
    - ``.deltaScale( dw:0.4, dy:0.4 )``
      - 毎フレーム、0.4ポイント拡大します。
    - ``.angle( degrees:0 )``
      - 角度。初期は0度を設定します。
    - ``.deltaAngle( degrees: 0.5 )``
      - 毎フレーム、0.5度回転します。
    - ``.alpha( 0 )``
      - アルファ。透明にします。
    - ``.life( .random )``
      - ライフ。0.0~1.0のランダムから開始
    - ``.deltaLife( -0.01 )``
      - 毎フレーム、lifeを0.01減少します。

---- 
 4. ``.iterate{ }`` を用意して、毎フレームのalphaの処理を計算します。
    - ``.life`` が0.5より大きいとき、 ``(1.0 - $0.life) * 2.0`` を設定します。
    - ``.life`` が0.5以下のとき、 `` $0.life * 2.0`` を設定します。
 
 上記の計算により、``life``が0.5の時、もっとも濃く描画します。``life``が0.5より少ない、あるいは多いときは薄くなります。

----
 5. ``.completion{ }`` を用意して、図形を再利用します。
     - ``.position( screen.randomPoint )``
       - 位置を画面内のランダムな座標へ移動します。
     - ``.scale( square:15 )``
       - 大きさを縦横15ポイントにもどします。
     - ``.angle( degrees:0 )``
       - 角度を0度にもどします。
     - ``.alpha( 0 )``
       - アルファを透明にもどします。
     - ``.life( 1.0 )``
       - ライフを1.0に回復します。

----
 6. 「コードを実行」を押します。
 
-----------------
## 目標
+ 画面内にキラキラ輝くエフェクトが表示されたら成功です。 [**結果の例**](glossary://result-2-3-1)
 
-----------------
[次のページ](@next)
 
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-editable-code
func design( screen:PGScreen ) {
    screen.clearColor = .darkGrey
     
    for _ in 0 ..< 50 {
        PGAddMask( "mask-sparkle" )
        
        
        
        
        
    }
}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
