//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, PGRectangle )identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, screen, minX, maxX, minY, maxY )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, deltaScale, deltaScale(dw:dh:) )
//#-code-completion(identifier, show, deltaColor, deltaColor(red:green:blue:) )
//#-code-completion(identifier, show, deltaAngle, deltaAngle(red:green:blue:) )
//#-code-completion(identifier, show, deltaAlpha, deltaAlpha() )
//#-code-completion(identifier, show, interval, interval(sec:) )
//#-code-completion(identifier, show, completion, completion(), completion{} )
//#-code-completion(identifier, show, life, life() )
//#-code-completion(identifier, show, deltaLife, deltaLife() )
//#-code-completion(identifier, show, iterate, iterate(), iterate{} )
/*:#localized( key:"--explain" )
# 3-2. 煙を焚く

[前のページ](@previous)
 
煙を表現するコードをつくりましょう。

 ````
 func design( screen:PGScreen ) {
     screen.clearColor = .darkGrey
     
     for _ in 0 ..< 60 {
         PGMask( "mask-smoke" )
         .color( .white )
         .position( 
             cx:(-150...150).randomize,
             cy:(-150...150).randomize
         )
         .scale( square:(80...160).randomize )
         .deltaScale( dw:1, dh:1 )
         .angle( .random )
         .life( .random )
         .deltaLife( -0.005 )
         .iterate {
            if $0.life < 0.5 {
               $0.alpha( $0.life )
            }
            else {
               $0.alpha( (1.0 - $0.life) )
            }
         }     
         .completion {
             $0
             .position( 
                 cx:(-150...150).randomize,
                 cy:(-150...150).randomize
             )
             .scale( square:80 )
             .angle( .random )
             .life( 1.0 )
         }
     }
 }
 ````
 
-----------------
 1. ``screen.clearColor = .darkGrey`` で背景を暗灰色にします。

---- 
 2. ``for``で60個のマスク画像 ``PGMask()`` を書きます。 画像ファイルは**mask-smoke.png**を指定します。

----
 3. 初期設定のコードを書きます。
    - ``.color( .white )``
      - 色。白を設定します。
    - ``.position( cx:(-150...150).randomize, cy:(-150...150).randomize )``
      - 位置。-150~150ポイントのランダム座標を設定します。 
    - ``.scale( square:(80...160).randomize )``
      - 大きさ。80~160ポイントのランダムなサイズを設定します。
    - ``.deltaScale( dw:1, dy:1 )``
      - 毎フレーム、1ポイント拡大します。
    - ``.angle( .random )``
      - 角度。0.0~1.0のランダムから開始します。
    - ``.life( .random )``
      - ライフ。0.0~1.0のランダムから開始します。
    - ``.deltaLife( -0.005 )``
      - 毎フレーム、lifeを0.005減少します。

---- 
 4. ``.iterate{ }`` を用意して、毎フレームのalphaの処理を計算します。
    - ``.life`` が0.5より大きいとき、 ``(1.0 - $0.life) * 2.0`` を設定します。
    - ``.life`` が0.5以下のとき、 ``$0.life * 2.0`` を設定します。
 
 上記の計算により、``life``が0.5の時、もっとも濃く描画します。``life``が0.5より少ない、あるいは多いときは薄くなります。

----
 5. ``.completion{ }`` を用意して、図形を再利用します。
    - ``.position( cx:(-150...150).randomize, cy:(-150...150).randomize )``
      - -150~150のランダム座標に再配置します。
    - ``.scale( square:80 )``
      - 大きさを縦横80ポイントに戻します。
    - ``.angle( .random )``
      - 角度を異なるランダム値に再設定します。
    - ``.life( 1.0 )``
      - ライフを1.0に回復します。
 
----
 6. 「コードを実行」を押します。
 
-----------------
## 目標
+ 煙が立つエフェクトが表示されたら成功です。 [**結果の例**](glossary://result-2-3-2)
 
-----------------
[次のページ](@next)
 
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-editable-code
func design( screen:PGScreen ) {
    screen.clearColor = .darkGrey
     
    for _ in 0 ..< 60 {
        PGMask( "mask-smoke" )
        
        
        
        
        
    }
}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
