//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, PGRectangle )identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, screen, minX, maxX, minY, maxY )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, deltaScale, deltaScale(dw:dh:) )
//#-code-completion(identifier, show, deltaColor, deltaColor(red:green:blue:) )
//#-code-completion(identifier, show, deltaAngle, deltaAngle(red:green:blue:) )
//#-code-completion(identifier, show, deltaAlpha, deltaAlpha() )
//#-code-completion(identifier, show, interval, interval(sec:) )
//#-code-completion(identifier, show, completion, completion(), completion{} )
//#-code-completion(identifier, show, life, life() )
//#-code-completion(identifier, show, deltaLife, deltaLife() )
//#-code-completion(identifier, show, iterate, iterate(), iterate{} )
/*:#localized( key:"--explain" )
# 3-3. 炎をあげる
 
[前のページ](@previous)

前のページの煙のコードを応用して、炎を表現してみましょう。
 
 ````
 func design( screen:PGScreen ) {
     screen.clearColor = .darkGrey
     
     for _ in 0 ..< 160 {
         PGAddMask( "mask-smoke" )
         .color( LLColor( 0.9, 0.34, 0.22, 1.0 ) )
         .position(
             cx:(-50 ... 50).randomize,
             cy:(-120 ... -110).randomize
         )
         .deltaPosition( 
             dx:(-1.0...1.0).randomize,
             dy:(0.5...4.5).randomize 
         )
         .scale( square: 80.0 )
         .deltaScale( dw: 0.5, dh: 0.5 )
         .angle( .random )
         .deltaAngle( degrees:(-2.0...2.0).randomize )
         .life( .random )
         .deltaLife( -0.01 )
         .iterate {
             if $0.life < 0.5 {
                $0.alpha( $0.life )                
             }
             else {
                $0.alpha( (1.0 - $0.life) )
             }
         }
         .completion {
             $0
             .position( 
                 cx:(-50 ... 50).randomize,
                 cy:(-120 ... -110).randomize 
             )
             .scale( square: 80.0 )
             .life( 1.0 )
         }
     }
 }
 ````
-----------------
 1. ``screen.clearColor = .darkGrey`` で背景を暗灰色にします。

---- 
 2. ``for``で160個の加算合成マスク画像 ``PGAddMask()`` を書きます。 画像ファイルは**mask-smoke.png**を指定します。

----
 3. 初期設定のコードを書きます。
    - ``.color( LLColor( 0.9, 0.34, 0.22, 1.0 ) )``
      - 色。少しオレンジがかった赤を設定します。
    - ``.position( cx:(-50...50).randomize, cy:(-120... -110).randomize )``
      - 位置。x方向は-50~50のランダム座標, y方向は-120~-110のランダム座標を設定します。 (xはある程度のブレがあり、yはほとんど違いのない位置になります)
    - ``.deltaPosition( dx:(-1.0...1.0).randomize, dy:(0.5...4.5).randomize )``
      - 毎フレーム、x方向に-1.0~1.0のランダムな等速移動量、y方向に0.5~4.5のランダムな等速移動量を設定します。 (yのプラスが大きいので、画面上方向へ大きく移動します)
    - ``.scale( square:80.0 )``
      - 大きさ。80.0ポイントを設定します。
    - ``.deltaScale( dw:0.5, dy:0.5 )``
      - 毎フレーム、0.5ポイント拡大します
    - ``.angle( .random )``
      - 角度。0.0~1.0のランダムから開始します。
    - ``.deltaAngle( degrees:(-2.0...2.0).randomize )``
      - 毎フレーム、-2.0~2.0度のランダム値で等速に回転します。
    - ``.life( .random )``
      - ライフ。0.0~1.0のランダムから開始します。
    - ``.deltaLife( -0.01 )``
      - 毎フレーム、lifeを0.01減少します。

---- 
 4. ``.iterate{ }`` を用意して、毎フレームのalphaの処理を計算します。
    - ``.life`` が0.5より小さいとき、 ``$0.life * 2.0`` を設定します。
    - ``.life`` が0.5以上のとき、 ``(1.0 - $0.life) * 2.0`` を設定します。

 
 上記の計算により、``life``が0.5の時、もっとも濃く描画します。``life``が0.5より少ない、あるいは多いときは薄くなります。

----
 5. ``.completion{ }`` を用意して、図形を再利用します。
    - ``.position( cx:(-50...50).randomize, cy:(-120... -110).randomize )``
      - x方向は-50~50のランダム座標、 y方向は-120~-110のランダム座標に再配置します。
    - ``.scale( square:80 )``
      - 大きさを縦横80ポイントに戻します。
    - ``.life( 1.0 )``
      - ライフを1.0に回復します。

----
 6. 「コードを実行」を押します。
 
-----------------
## 目標
+ 炎が立ち上がるエフェクトが表示されたら成功です。 [**結果の例**](glossary://result-2-3-3)
 
-----------------
終わったら[次のページ](@next)へ進みます。
 
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-editable-code
func design( screen:PGScreen ) {
    screen.clearColor = .darkGrey
     
    for _ in 0 ..< 160 {
        PGAddMask( "mask-smoke" )
        
        
        
        
        
    }
}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
