//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, PGRectangle )identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, screen, minX, maxX, minY, maxY )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, deltaScale, deltaScale(dw:dh:) )
//#-code-completion(identifier, show, deltaColor, deltaColor(red:green:blue:) )
//#-code-completion(identifier, show, deltaAngle, deltaAngle(red:green:blue:) )
//#-code-completion(identifier, show, deltaAlpha, deltaAlpha() )
//#-code-completion(identifier, show, interval, interval(sec:) )
//#-code-completion(identifier, show, completion, completion(), completion{} )
//#-code-completion(identifier, show, life, life() )
//#-code-completion(identifier, show, deltaLife, deltaLife() )
//#-code-completion(identifier, show, iterate, iterate(), iterate{} )
/*:#localized( key:"--explain" )
# 3-4. うねる発光体

[前のページ](@previous)
 
ここでは、ぼやけた円と加算合成をつかって、発光体を表現してみます。

 ````
 func design( screen:PGScreen ) {
     screen.clearColor = .darkGrey
     
     for _ in 0 ..< 80 {
         PGAddBlurryCircle()
         .color( .random )
         .position( screen.randomPoint )
         .scale( square: 100.0 )
         .deltaScale( dw: 0.5, dh: 0.5 )
         .alpha( 0 )
         .life( .random )
         .deltaLife( -0.003 )
         .iterate {
             $0.alpha( sin( $0.life * Float.pi ) )
         }
         .completion {
             $0
             .color( .random )
             .position( screen.randomPoint )
             .scale( square: 100.0 )
             .life( 1.0 )
             .alpha( 0 )
         }
     }
 }
 ```` 
-----------------
 1. ``screen.clearColor = .darkGrey`` で背景を暗灰色にします。

---- 
 2. ``for``で80個の加算合成のぼやけた縁 ``PGAddBlurryCircle()`` を書きます。 
 
----
 3. 初期設定のコードを書きます。
    - ``.color( .random )``
      - 色。ランダムを設定します。
    - ``.position( screen.randomPoint )``
      - 位置。画面内のランダム座標を設定します。
    - ``.scale( square:100.0 )``
      - 大きさ。100.0ポイントを設定します。
    - ``.deltaScale( dw:0.5, dy:0.5 )``
      - 毎フレーム、0.5ポイント拡大します。
    - ``.alpha( 0 )``
      - アルファ。透明から開始します。
    - ``.life( .random )``
      - ライフ。0.0~1.0のランダムから開始します。
    - ``.deltaLife( -0.003 )``
      - 毎フレーム、lifeを0.003減少します。

---- 
 4. ``.iterate{ }`` を用意して、毎フレームのalphaの処理を計算します。
    - ``.alpha( sin( $0.life * Float.pi ) )``
      - lifeに合わせたサイン値です。

 上記の計算で、``.life``=1.0で透明、0.5のときにもっとも濃くなり、0.0で透明に戻ります。
 
----
 5. ``.completion{ }`` を用意して、図形を再利用します。
    - ``.color( .random )``
      - 色をランダムに再設定します。
    - ``.position( screen.randomPoint )``
      - 画面内のランダム座標に再配置します。
    - ``.scale( square:100 )``
      - 大きさを縦横100ポイントに戻します。
    - ``.life( 1.0 )``
      - ライフを1.0に回復します。
    - ``.alpha( 0 )``
      - アルファを透明に戻します。
 
----
 6. 「コードを実行」を押します。
 
-----------------
## 目標
+ ゆったり発光体が動くエフェクトが表示されたら成功です。 [**結果の例**](glossary://result-2-3-4)
 
-----------------
終わったら[次のページ](@next)へ進みます。
 
-----------------  
- Note:
``sin()`` は、ラジアン値を渡すとサインの値を返します。
 - sin( 0 ) = 0.0
 - sin( 0.5π ) = 1.0
 - sin( 1.0π ) = 0.0

*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-editable-code
func design( screen:PGScreen ) {
    screen.clearColor = .darkGrey
    
    for _ in 0 ..< 80 {
        PGAddBlurryCircle()
    
        
        
        
        
        
    }
}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
