//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, PGRectangle )identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, screen, minX, maxX, minY, maxY )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, deltaScale, deltaScale(dw:dh:) )
//#-code-completion(identifier, show, deltaColor, deltaColor(red:green:blue:) )
//#-code-completion(identifier, show, deltaAngle, deltaAngle(red:green:blue:) )
//#-code-completion(identifier, show, deltaAlpha, deltaAlpha() )
//#-code-completion(identifier, show, interval, interval(sec:) )
//#-code-completion(identifier, show, completion, completion(), completion{} )
//#-code-completion(identifier, show, life, life() )
//#-code-completion(identifier, show, deltaLife, deltaLife() )
//#-code-completion(identifier, show, iterate, iterate(), iterate{} )
/*:#localized( key:"--explain" )
# 3-5. 噴水

[前のページ](@previous)
 
前のページと同様、ぼやけた円と加算合成を用いて、噴水のような表現を考えてみます。

 ````
 func design( screen:PGScreen ) {
     screen.clearColor = .darkGrey
     
     for _ in 0 ..< 1000 {
         PGAddBlurryCircle()
         .color( LLColor( 0.16, 0.3, 0.5, 0.8 ) )
         .position( 
             cx:(-10...10).randomize,
             cy:screen.minY - (0.0...48.0).randomize
         ) 
         .deltaPosition( 
             dx:(-2.0...2.0).randomize,
             dy:(19.0...20.0).randomize
         )
         .scale( square: 48.0 )
         .life( .random )
         .deltaLife( -0.008 )
         .iterate {
             $0.deltaPosition( 
                 dx:$0.deltaPosition.x,
                 dy:$0.deltaPosition.y - 0.35
             )
         }
         .completion {
             $0
             .position(
                 cx:(-10...10).randomize,
                 cy:screen.minY - (0.0...48.0).randomize
             ) 
             .deltaPosition(
                 dx:(-2.0...2.0).randomize,
                 dy:(19.0...20.0).randomize 
             )
             .life( 1.0 )
         }
     }
 }
 ````
-----------------
 1. ``screen.clearColor = .darkGrey`` で背景を暗灰色にします。

---- 
 2. ``for``で1000個の加算合成のぼやけた円 ``PGAddBlurryCircle()`` を書きます。 
 
----
 3. 初期設定のコードを書きます。
    - ``.color( LLColor( 0.16, 0.3, 0.5, 0.8 ) )``
      - 色。水色を設定します。
    - ``.position( cx:(-10...10).randomize, cy:screen.minY - (0.0...48.0).randomize )``
      - 位置。x方向は中央付近, y方向は画面下へ配置します。
    - ``.deltaPosition( dx:(-2.0...2.0).randomize, dy:(19.0...20.0).randomize )``
      - 毎フレーム、x方向に-2.0~2.0ポイントのランダムに移動, y方向に約20ポイント移動します。（少し左右に振れつつ、上方向へ飛び上がります）
    - ``.scale( square:48.0 )``
      - 大きさ。48.0ポイントを設定します。
    - ``.alpha( 0 )``
      - アルファ。透明を設定します。
    - ``.life( .random )``
      - ライフ。0.0~1.0のランダムを設定します。
    - ``.deltaLife( -0.008 )``
      - 毎フレーム、lifeを0.008減少します。

---- 
 4. ``.iterate{ }`` を用意して、毎フレームのdeltaPositionを変化します。
    - ``.deltaPosition( dx:$0.deltaPosition.x, dy:$0.deltaPosition.y - 0.35 )``
      - x方向の移動量は変化なし, y方向の移動量を-0.35していきます。

 上記の計算により、だんだんと上方向への移動量が減り、下に落ちるようになります。
 
----
 5. ``.completion{ }`` を用意して、図形を再利用します。
    - ``.position( cx:(-10...10).randomize, cy:screen.minY - (0.0...48.0).randomize )``
      - 位置をx方向は中央付近, y方向は画面下へ戻します。
    - ``.deltaPosition( dx:(-2.0...2.0).randomize, dy:(19.0...20.0).randomize )``
      - 毎フレームの移動量を初期値にもどします。
    - ``.life( 1.0 )``
      - ライフを1.0に回復します。
 
----
 6. 「コードを実行」を押します。
 
-----------------
## 目標
+ 噴水のようなエフェクトが表示されたら成功です。 [**結果の例**](glossary://result-2-3-5)
 
-----------------
終わったら[次のページ](@next)へ進みます。
 
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-editable-code
func design( screen:PGScreen ) {
    screen.clearColor = .darkGrey
    
    for _ in 0 ..< 1000 {
        PGAddBlurryCircle()
    
        
        
        
        
        
    }
}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
