//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, screen, minX, maxX, minY, maxY )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, deltaScale, deltaScale(dw:dh:) )
//#-code-completion(identifier, show, deltaColor, deltaColor(red:green:blue:) )
//#-code-completion(identifier, show, deltaAngle, deltaAngle(red:green:blue:) )
//#-code-completion(identifier, show, deltaAlpha, deltaAlpha() )
//#-code-completion(identifier, show, interval, interval(sec:) )
//#-code-completion(identifier, show, completion, completion(), completion{} )
//#-code-completion(identifier, show, life, life() )
//#-code-completion(identifier, show, deltaLife, deltaLife() )
//#-code-completion(identifier, show, iterate, iterate(), iterate{} )
/*:#localized( key:"--explain" )
# 3-8. 跳ね返る円

[前のページ](@previous)
 
壁に跳ね返るボールを表現してみましょう。
 
 ````
 func design( screen:PGScreen ) {
     screen.clearColor = .black
     
     for _ in 0 ..< 20 {
         let speed = (4.0...8.0).randomize
         let radians = (0.0...2.0).randomize * Double.pi
         let dx = speed * cos( radians )
         let dy = speed * sin( radians )
         
         PGAddCircle()
         .color( .random )
         .position( 
             cx: (screen.minX + 30 ... screen.maxX - 30).randomize,
             cy: (screen.minY + 30 ... screen.maxY - 30).randomize
         )
         .deltaPosition( 
             dx:dx,
             dy:dy
         )
         .scale( square:60 )
         .iterate {
             if $0.position.x - 30 <= Float( screen.minX ) {
                 $0.deltaPosition.x *= -1
             }
             
             if  Float( screen.maxX ) <= $0.position.x + 30 {
                 $0.deltaPosition.x *= -1
             }
             
             if $0.position.y - 30 <= Float( screen.minY ) {
                 $0.deltaPosition.y *= -1
             }
             
             if Float( screen.maxY ) <= $0.position.y + 30 {
                 $0.deltaPosition.y *= -1
             }
         }    
     }
 }
 ````
-----------------
 1. ``screen.clearColor = .black`` で背景を黒にします。

---- 
 2. ``for``で、20回繰り返します。 
 
----
 3. ``for``の中に、初期設定に必要な変数をつくります。
    - ``let speed = (4.0...8.0).randomize``
      - 速度用の変数。4.0~8.0のランダム値をつくり、代入します。
    - ``let radians = (0.0...2.0).randomize * Double.pi``
      - 進行方向の角度の変数。0~2πのランダムの値をつくり、代入します。
    - ``let dx = speed * cos( radians )``
      - x方向の移動量の変数。変数radiansのコサイン値とspeedを掛け算した値を代入します。
    - ``let dy = speed * sin( radians )``
      - y方向の移動量の変数。変数radiansのサイン値とspeedを掛け算した値を代入します。

 ---- 
 4.  ``for``の中で、加算合成の円 ``PGAddCircle()`` をつくります。
 
---- 
 5. PGAddCircleの初期設定のコードを書きます。円の大きさは60ポイント、半径が30ポイントになります。
    - ``.color( .random )``
      - 色。ランダムな色を設定します。
    - `` .position( cx: (screen.minX + 30 ... screen.maxX - 30).randomize, cy: (screen.minY + 30 ... screen.maxY - 30).randomize )``
      - 位置。x方向は左端+30~右端-30のランダム、 y方向は上端-30~下端+30ポイントのランダム座標に設定します。
    - `` .deltaPosition( dx:dx, dy:dy )``
      - 毎フレームの移動量。x方向は変数dx、 y方向は変数dyの値を設定します。
    - ``.scale( square:60 )``
      - 大きさ。60ポイントを設定します。
 
----  
 6. ``.iterate{ }`` を用意します。位置によって図形の移動方向を変えます。
 
    - ``if $0.position.x - 30 <= Float( screen.minX ) { ... }``
      - 図形の中央x座標 - 30ポイント(円の半径)が、画面の左端に到達したとき、{ }の中の処理を行います。
    - `` Float( screen.maxX ) <= $0.position.x + 30 { ... }``
      - 図形の中央x座標 + 30ポイント(円の半径)が、画面の右端に到達したとき、{ }の中の処理を行います。
    - ``$0.deltaPosition.x *= -1``
      - x方向の移動量の正負を逆にします。
    - ``if $0.position.y - 30 <= Float( screen.minX ) { ... }``
      - 図形の中央y座標 - 30ポイント(円の半径)が、画面の下端に到達したとき、{ }の中の処理を行います。
    - ``$0.position.y + 30 >= Float( screen.maxX ) { ... }``
      - 図形の中央y座標 + 30ポイント(円の半径)が、画面の上端に到達したとき、{ }の中の処理を行います。
    - ``$0.deltaPosition.y *= -1``
      - y方向の移動量の正負を逆にします。

----
 7. 「コードを実行」を押します。
 
-----------------
## 目標
+ ボールが画面端で跳ね返る絵が表示されたら成功です。 [**結果の例**](glossary://result-2-3-8)
 
-----------------
終わったら[次のページ](@next)へ進みます。

*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-editable-code
func design( screen:PGScreen ) {
    screen.clearColor = .black
    
    for _ in 0 ..< 20 {
        
        
        
        
        
        
    }
}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design

//#-end-hidden-code
