//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, screen, randomPoint, .randomPoint )
//#-code-completion(identifier, show, screen, minX, maxX, minY, maxY )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, deltaScale, deltaScale(dw:dh:) )
//#-code-completion(identifier, show, deltaColor, deltaColor(red:green:blue:) )
//#-code-completion(identifier, show, deltaAngle, deltaAngle(red:green:blue:) )
//#-code-completion(identifier, show, deltaAlpha, deltaAlpha() )
//#-code-completion(identifier, show, interval, interval(sec:) )
//#-code-completion(identifier, show, completion, completion(), completion{} )
//#-code-completion(identifier, show, life, life() )
//#-code-completion(identifier, show, deltaLife, deltaLife() )
//#-code-completion(identifier, show, iterate, iterate(), iterate{} )
//#-code-completion(identifier, show, cx, cy, width, height )
/*:#localized( key:"--explain" )
# 3-9. 花火
 
[前のページ](@previous)

このページでは、次のBooksで紹介する新しい仕組みを先取りし、花火を表現します。
 
 ````
 func design( screen:PGScreen ) {
     screen.clearColor = LLColor( 0.0, 0.05, 0.2, 1.0 )
 }

 func update( screen:PGScreen ) {
     if (0.0...1.0).randomize < 0.97 { return }
     
     let size = (10.0...20.0).randomize
     let speed = size / 4.0
     let pos = screen.randomPoint
     let c = LLColor.random
    
     for _ in 0 ..< 150 {
         let radians = (0.0...2.0).randomize * Double.pi
         let speed2 = speed * (0.65...1.0).randomize
         let dx = speed2 * cos( radians )
         let dy = speed2 * sin( radians )
         
         PGAddBlurryCircle()
         .color( c )
         .position( pos )
         .deltaPosition( 
             dx:dx,
             dy:dy
         )
         .deltaLife( -0.005 )
         .scale( square:size )
         .iterate {
             $0
             .deltaPosition( 
                 dx:$0.deltaPosition.x * 0.985,
                 dy:$0.deltaPosition.y * 0.985
             )
             .cy( $0.cy - 1.5 )
             .alpha( $0.life )
         }        
     }
 }
 ````
-----------------
 1. ``func design( screen:PGScreen ) { }`` に加えて、``func update( screen:PGScreen ) { }`` 関数を追加します。この``update``が新しい仕組みです。毎フレーム繰り返し処理される関数です。

----
 2. ``design( screen:PGScreem )`` 内に ``screen.clearColor = LLColor( 0.0, 0.05, 0.2, 1.0 )`` を書き、背景を群青色にします。``design( screen:PGScreem )``のコードはこれで完了です。

---- 
 3. ``update( screen:PGScreen )``内に処理を書いていきます。まず図形をつくる確率を調整します。
     - ``if (0.0...1.0).randomize < 0.97 { return }``
       - 97%の確率で何もせず、update関数を終了(return)します。
 
``update( screen:PGScreen )``は毎秒最大60回実行されます。 上記の処理により、updateが呼ばれたら3%の確率で処理を継続します。
 
----
 4. この後図形をたくさんつくりますが、その準備として、図形で共通で使う変数をつくります。
    - ``let size = (10.0...20.0).randomize``
      - 大きさ用の変数。10.0~20.0のランダム値をつくり、代入します。
    - ``let speed = size / 4.0``
      - 速度用の変数。sizeを4.0で割った値をつくり、代入します。
    - ``let pos = screen.randomPoint``
      - 図形の位置の変数。画面内のランダム位置を代入します。この変数を使い、同じ座標に複数の図形をつくります。
    - ``let c = LLColor.random``
      - 色の変数。ランダムの値を代入します。この変数を使い、複数の図形を同じ色にします。

---- 
 5. ``for``を150回繰り返します。
 
----
 6. ``for``の中で、図形1つずつの初期設定用の変数をつくります。
    - ``let radians = (0.0...2.0).randomize * Double.pi``
      - 進行方向の角度の変数。0~2πのランダムの値をつくり、代入します。
    - ``let speed2 = speed * (0.65...1.0).randomize``
      - 図形ごとの速度用の変数。共通の変数speedに0.65~1.0のランダム値を掛け算し、代入します。
    - ``let dx = speed2 * cos( radians )``
      - x方向の移動量の変数。変数radiansのコサイン値とspeed2を掛け算した値を代入します。
    - ``let dy = speed 2* sin( radians )``
      - y方向の移動量の変数。変数radiansのサイン値とspeed2を掛け算した値を代入します。

 ---- 
 7.  加算合成の円 ``PGAddCircle()`` をつくります。
 
---- 
 8. PGAddCircleの初期設定のコードを書きます。
    - ``.color( c )``
      - 色。変数cを設定します。
    - ``.position( pos )``
      - 位置。変数posを設定します。
    - ``.deltaPosition( dx:dx, dy:dy )``
      - 毎フレームの移動量。x方向は変数dx、 y方向は変数dyの値を設定します。
    - ``.deltaLife( -0.005 )``
      - 毎フレーム、lifeを0.005減少します。
    - ``.scale( square:size )``
      - 大きさ。変数sizeを設定します。
 
----
 9. ``.iterate{ }`` を用意します。位置によって図形の移動方向を変えます。
    - ``.deltaPosition( dx:$0.deltaPosition.x * 0.985, dy:$0.deltaPosition.y * 0.985 )``
      - 毎フレームの移動量を0.985倍します。だんだんと移動がゆっくりになります。
    - ``.cy( $0.cy - 1.5 )``
      - y方向の位置を-1.5ずつ移動します。等速で画面の下へ移動します。
    - ``.alpha( $0.life )``
      - アルファの値をライフに合わせて設定します。

----
 10. 「コードを実行」を押します。
 
-----------------
## 目標
+ 不定期に花火が画面に表示されたら成功です。 [**結果の例**](glossary://result-2-3-9)
 
-----------------
終わったら[次のページ](@next)へ進みます。
 
-----------------  
 - Note:
  このページのコードで``update( screen:PGScreen )``関数を使いました。各図形の毎フレームの処理は ``.iterate{ }``を使いますが、プログラム全体の毎フレームの処理は ``update( screen:PGScreen )`` を使います。例えば、今回の花火のように、**図形に関係なく、フレームごとに処理したいとき**に有効です。
 
-----------------  
 - Note:
  ``.cy`` は、``.position.y`` と同じものです。
 
*/
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-editable-code
func design( screen:PGScreen ) {
    screen.clearColor = LLColor( 0.0, 0.05, 0.2, 1.0 )
}

func update( screen:PGScreen ) {
    if (0.0...1.0).randomize < 0.97 { return }
    
    

}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design
vc.pgUpdateHandler = update

//#-end-hidden-code
