//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, coordRegion, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, screen, clearColor, latestTouch, removeAllShapes )
//#-code-completion(identifier, show, xy )
/*:#localized( key:"--explain" )
# 1-1. タッチ位置に円を描く
このBookでは、タッチに反応して図形を描くプログラミングしていきます。
タッチに合わせて動くエフェクトはとても魅力的です。表現を工夫して楽しいエフェクトを作っていきましょう。
 
手始めに、タッチしたところに円を描くプログラムを書きましょう。

前のBookでは実行時に1度だけ処理するdesign関数をつかいました。
このBookから、design関数に加え、update関数をつかいます。
update関数は繰り返し呼ばれる関数です。呼ばれるたびにタッチの情報を更新するため、今タッチしている位置が得られます。``screen.latestTouch`` が最新の触れた位置の情報です。

-----------------
 1. design関数に ``screen.clearColor = .lightGrey`` を書きます。
 背景を薄灰色に設定します。
 
 2. update関数を用意します。
 
 3. update関数のはじめに、``screen.removeAllShapes()`` を書きます。
 一度すべての図形を消す処理です。updateは繰り返し呼ばれるので前のフレームの図形が残ります。
 今回は前フレームの図形を消すため、``removeAllShapes()``を呼びます。
 
 4. ``let touch = screen.latestTouch``を書きます。
 最新のタッチ情報がtouchに入ります。
 
 5. ``PGCircle()`` を書きます。
 
 6. PGCircle()に ``.position( touch.xy )`` を追加します。
 touch.xyはタッチ情報のxy座標が得られます。
 
 ````
 func design( screen:PGScreen ) {
    screen.clearColor = .lightGrey
 }
 
 func update( screen:PGScreen ) {
    screen.removeAllShapes()
    
    let touch = screen.latestTouch
    
    PGCircle()
    .position( touch.xy )
 }
 ````
 7. 「コードを実行」を押します。
 
-----------------
## 目標
+ 実行後、タッチした位置に丸が描けたら成功です。 [**結果の例**](glossary://result-3-1-1)
+ **(+1)** ``PGCircle()`` を ``PGRectangle()`` や ``PGTriangle()`` など別の形に変えてみましょう。
 
-----------------
終わったら[次のページ](@next)へ進みます。
*/

//#-editable-code
func design( screen:PGScreen ) {
    
}

func update( screen:PGScreen ) {

}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design
vc.pgUpdateHandler = update

//#-end-hidden-code
