//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, coordRegion, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, screen, clearColor, latestTouch, removeAllShapes )
//#-code-completion(identifier, show, xy )
//#-code-completion(identifier, show, touches, . )
//#-code-completion(identifier, show, count )
/*:#localized( key:"--explain" )
# 1-2. タッチの軌跡を描く
[前のページ](@previous)では、updateのはじめに ``screen.removeAllShapes()`` をつかって前の図形を消していました。そのため図形はタッチ位置に1つのみでした。
 
今回は、前のタッチ位置に描いた図形を残します。さらに新たなタッチ位置に図形を加えます。

しかし、図形が増えすぎてもいけません。``.deltaLife`` と ``.deltaAlpha`` を使って、時間が経つと消滅するように工夫します。
 
-----------------
 1. design関数に ``screen.clearColor = .lightGrey`` を書きます。
 背景を薄灰色に設定します。
 
 2. update関数を用意します。
 
 3. ``let touch = screen.latestTouch``を書きます。
 最新のタッチ情報を取得します。
 
 4. ``PGCircle()`` を書きます。
 
 5. PGCircle()に ``.position( touch.xy )`` を追加します。

 6. 続けて ``.deltaLife( -0.05 )``、 ``.deltaAlpha( -0.05 )`` を追加します。lifeが減っていくようになります。lifeが0.0になるとPGCircleが消滅します。lifeと合わせてalphaも減らすことで、徐々に消える様子を表現します。
 
 ````
 func design( screen:PGScreen ) {
     screen.clearColor = .lightGrey
 }

 func update( screen:PGScreen ) {
     let touch = screen.latestTouch
     
     PGCircle()
     .position( touch.xy )
     .deltaLife( -0.05 )
     .deltaAlpha( -0.05 )
 }
 ````
 7. 「コードを実行」を押します。
 
-----------------
## 目標
+ 実行後、タッチの軌跡が描ければ成功です。 [**結果の例**](glossary://result-3-1-2)

-----------------
終わったら[次のページ](@next)へ進みます。
 
-----------------
- Note:
  alpha、lifeの初期値はともに **1.0** です。今回のコードの場合、1.0から0.05ずつ減っていき、0.0になると消滅します。
*/

//#-editable-code
func design( screen:PGScreen ) {
    screen.clearColor = .lightGrey
}

func update( screen:PGScreen ) {

}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design
vc.pgUpdateHandler = update

//#-end-hidden-code
