//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, coordRegion, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, screen, clearColor, latestTouch, removeAllShapes )
//#-code-completion(identifier, show, xy )
//#-code-completion(identifier, show, touches, . )
//#-code-completion(identifier, show, count )
/*:#localized( key:"--explain" )
# 1-3. タッチと図形のアニメーション1 - 回転とズーム
[前のページ](@previous)では、タッチ位置に図形を生成し、``.life``の値を用いて徐々に消えていくようにしました。
前のフレームで描いた図形が少し残るため、タッチの軌跡を表現できました。
 
今回は、図形の角度と大きさの変化を加えて、図形の表現を豊かにしていきましょう。
 
-----------------
 1. design関数に ``screen.clearColor = .white`` を書きます。
 背景は白に設定します。
 
 2. update関数を用意します。
 
 3. ``if screen.touches.count == 0 { return }``を書きます。
 タッチしている指の数が0のとき、図形を描かないようになります。
 
 4. ``let touch = screen.latestTouch``を書きます。
 最新のタッチ情報を取得します。
 
 5. ``let d_scale = (0.5...1.0).randomize``を書き、0.5~1.0のランダム値をd_scaleに代入します。後述する``.deltaScale``に用います。
 
 6. ``PGRectangle()`` を書きます。
 
 7. PGRectangle()に ``.position( touch.xy )``を加えます。前ページと同様です。

 8. 続けて、``.color( .random )``, ``.scale( .zero )``, ``.angle( .random )``を追加します。図形作成時の初期値です。色、角度はランダム、大きさはゼロにします。
 
 9. 次に、``.deltaAngle( degrees:1.0 )``を追加して回転を加えます。また``.deltaScale(dw:dh)``を追加し、変数``d_scale``を用いて拡大を行います。
 
 10.  ``.deltaLife( -0.05 )``、 ``.deltaAlpha( -0.05 )`` を前ページと同様に追加します。lifeが減っていき、同時にalphaも減らすことで透明になっていきます。
 
 ````
 func design( screen:PGScreen ) {
     screen.clearColor = .white
 }

 func update( screen:PGScreen ) {
     if screen.touches.count == 0 { return }
     
     let touch = screen.latestTouch
     
     let d_scale = (0.5...1.0).randomize
     
     PGRectangle()
     .position( touch.xy )
     .color( .random )
     .scale( .zero )
     .angle( .random )
     .deltaAngle( degrees:1.0 )
     .deltaScale(
         dw:d_scale,
         dh:d_scale 
     )
     .deltaLife( -0.01 )
     .deltaAlpha( -0.01 )
 }
 ````
 11. 「コードを実行」を押します。
 
-----------------
## 目標
+ 実行後、タッチの軌跡に回転と拡大する四角が描画がされれば成功です。 [**結果の例**](glossary://result-3-1-3)

-----------------
終わったら[次のページ](@next)へ進みます。
 
*/

//#-editable-code
func design( screen:PGScreen ) {
    screen.clearColor = .white
}

func update( screen:PGScreen ) {
    
    
    
}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design
vc.pgUpdateHandler = update

//#-end-hidden-code
