//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, coordRegion, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, screen, clearColor, latestTouch, removeAllShapes )
//#-code-completion(identifier, show, xy )
//#-code-completion(identifier, show, touches, . )
//#-code-completion(identifier, show, count )
/*:#localized( key:"--explain" )
# 1-4. タッチと図形のアニメーション2 - 移動と複数描画
[前のページ](@previous)では、タッチで生成した図形に大きさや角度のアニメーションを加えました。
 
今回は、1度のタッチで複数の図形を描き、動かしてみましょう。
 
 
-----------------
 1. design関数に ``screen.clearColor = .white`` を書きます。
 背景は白に設定します。
 
 2. update関数を用意します。
 
 3. ``if screen.touches.count == 0 { return }``を書きます。
 タッチしている指の数が0のとき、図形を描かないようになります。
 
 4. ``let touch = screen.latestTouch``を書きます。
 最新のタッチ情報を取得します。
 
 5. ``for _ in 0 ..< 4``を書きます。1度のタッチで4つの図形を生成します。
 
 6. for分の中で``PGRectangle()``を書きます。
 
 7. PGRectangle()に前ページと同様の記述を追加します。ただし、``let d_scale``のランダム値の範囲は``(0.25...0.5).randomize``に変更します。
 
 8. 次に、``.deltaPosition(dx:dy)``を追加し、``(-2.0...2.0).randomize``でランダムな方向に図形が移動するようにします。
 
 ````
 func design( screen:PGScreen ) {
     screen.clearColor = .white
 }

 func update( screen:PGScreen ) {
     if screen.touches.count == 0 { return }
     
     let touch = screen.latestTouch
     
     for _ in 0 ..< 4 {
         let d_scale = (0.25...0.5).randomize
         
         PGRectangle()
         .position( touch.xy )
         .deltaPosition(
             dx:(-2.0...2.0).randomize,
             dy:(-2.0...2.0).randomize
         )
         .color( .random )
         .scale( .zero )
         .angle( .random )
         .deltaAngle( degrees:1.0 )
         .deltaScale( 
             dw:d_scale,
             dh:d_scale            
         )
         .deltaLife( -0.01 )
         .deltaAlpha( -0.01 )
     }
 }
 ````
 9. 「コードを実行」を押します。
 
-----------------
## 目標
+ 実行後、タッチの軌跡から四角が拡散し、紙吹雪のようなエフェクトが表示されたら成功です。 [**結果の例**](glossary://result-3-1-4)

-----------------
終わったら[次のページ](@next)へ進みます。
 
*/

//#-editable-code
func design( screen:PGScreen ) {
    screen.clearColor = .white
}

func update( screen:PGScreen ) {

}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design
vc.pgUpdateHandler = update

//#-end-hidden-code
