//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, coordRegion, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, screen, clearColor, latestTouch, removeAllShapes )
//#-code-completion(identifier, show, xy )
//#-code-completion(identifier, show, touches, . )
//#-code-completion(identifier, show, count )
/*:#localized( key:"--explain" )
# 1-5. マルチタッチ
[前のページ](@previous)までで、タッチ位置に複数の図形を描き、アニメーションを表現しました。
 
ここではマルタタッチに挑戦します。LilyPlaygroundでは、``screen.touches``で複数のタッチ位置を得られます。
for文を用いて、複数の指の位置に図形を描いてみましょう。
 
-----------------
 1. design関数に ``screen.clearColor = .white`` を書きます。
 背景は白に設定します。
 
 2. update関数を用意します。

 3. ``for touch in screen.touches``の繰り返しブロックを書きます。``touch``にはタッチの座標が順に代入されます。
 
 4. forのブロックの中で``PGRectangle()``を書きます。加えて、前ページと同様の記述を追加します。
 
 ````
 func design( screen:PGScreen ) {
     screen.clearColor = .white
 }

 func update( screen:PGScreen ) {
     for touch in screen.touches {
         let d_scale = (0.25...0.5).randomize
             
         PGRectangle()
         .position( touch.xy )
         .color( .random )
         .scale( .zero )
         .angle( .random )
         .deltaAngle( degrees:1.0 )
         .deltaScale( 
             dw:d_scale,
             dh:d_scale            
         )
         .deltaLife( -0.01 )
         .deltaAlpha( -0.01 )
     }
 }
 ````
 5. 「コードを実行」を押します。
 
-----------------
## 目標
+ 実行後、複数のタッチに反応したら成功です。 [**結果の例**](glossary://result-3-1-5)
 
なお結果例はシングルタッチの結果です。iPadでマルチタッチを試してみてください。
 
-----------------
終わったら[次のページ](@next)へ進みます。
 
*/

//#-editable-code
func design( screen:PGScreen ) {
    screen.clearColor = .white
}

func update( screen:PGScreen ) {

}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design
vc.pgUpdateHandler = update

//#-end-hidden-code
