//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, coordRegion, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, screen, clearColor, latestTouch, removeAllShapes )
//#-code-completion(identifier, show, xy )
//#-code-completion(identifier, show, touches, . )
//#-code-completion(identifier, show, count )
/*:#localized( key:"--explain" )
# 1-6. 指が離れたときを捉える
[前のページ](@previous)では、マルチタッチを試しました。
 
Lily Playgroundではタッチしたときのように、指が離れた瞬間をとることもできます。

``screen.releases``で指が離れた瞬間に異なるエフェクトを加えてみましょう。
 
-----------------
 1. 準備として、前回のコードを用意してあります。ここにコードを追加していきます。
 
 2. screen.touchesのループの下に、``screen.releases``のfor文を追加します。使い方はscreen.touchesと同様です。
 
 3. screen.releasesのfor文の中に、``for _ in 0 ..< 32``を書きます。
 
 4. 上の32回のループの中で、``PGRectangle()``を書きます。``.position()``に``release.xy``を設定して、指を離した位置に図形を描きます。
 
 5. 続いて、``.deltaPosition(dx:dy:)``, ``.color()``, ``.scale()``, ``.angle()``,``.deltaAngle(degrees:)``, ``.deltaScale(dw:dh:)``, ``.deltaLife()``, ``.deltaAlpha()``を追加します。ランダムに図形が散らばるアニメーションです。
 
 ````
 func design( screen:PGScreen ) {
     screen.clearColor = .white
 }

 func update( screen:PGScreen ) {
     for touch in screen.touches {
         let d_scale = (0.25...0.5).randomize
             
         PGRectangle()
         .position( touch.xy )
         .color( .random )
         .scale( width:0.0, height:0.0 )
         .angle( .random )
         .deltaAngle( degrees:1.0 )
         .deltaScale( 
             dw:d_scale,
             dh:d_scale            
         )
         .deltaLife( -0.01 )
         .deltaAlpha( -0.01 )
     }
     
     for release in screen.releases {
         for _ in 0 ..< 32 {
             let d_scale = (0.25...0.5).randomize
             
             PGRectangle()
             .position( release.xy )
             .deltaPosition(
                 dx:(-2.0...2.0).randomize,
                 dy:(-2.0...2.0).randomize
             )
             .color( .random )
             .scale( .zero )
             .angle( .random )
             .deltaAngle( degrees:1.0 )
             .deltaScale( 
                 dw:d_scale,
                 dh:d_scale   
             )
             .deltaLife( -0.01 )
             .deltaAlpha( -0.01 )
         }
     }
 }
 ````
 6. 「コードを実行」を押します。
 
-----------------
## 目標
+ 実行後、タッチの軌跡を描き、指を離したときに図形が散るエフェクトが描けたら成功です。 [**結果の例**](glossary://result-3-1-6)

-----------------
終わったら[次のページ](@next)へ進みます。
 
-----------------
 - Note:
   screen.releasesは、指が離れたとき1フレームのみ値が入ります。次のフレームでは値がなくなります。
*/

//#-editable-code
func design( screen:PGScreen ) {
    screen.clearColor = .white
}

func update( screen:PGScreen ) {
    for touch in screen.touches {
        let d_scale = (0.25...0.5).randomize
            
        PGRectangle()
        .position( touch.xy )
        .color( .random )
        .scale( width:0.0, height:0.0 )
        .angle( .random )
        .deltaAngle( degrees:1.0 )
        .deltaScale( 
            dw:d_scale,
            dh:d_scale            
        )
        .deltaLife( -0.01 )
        .deltaAlpha( -0.01 )
    }
    
    
}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design
vc.pgUpdateHandler = update

//#-end-hidden-code
