//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, coordRegion, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, screen, clearColor, latestTouch, removeAllShapes )
//#-code-completion(identifier, show, xy )
/*:#localized( key:"--explain" )
# 2-1. 拡散光エフェクト

[前の章](@previous)で、タッチ位置の使い方の基礎を学びました。
 
この章では、これまで学んだことを応用して、タッチ時のエフェクトのバライエティを生み出していきましょう。
 
このページでは、BlurryCircleの加算合成で光の粒を表現し、鮮やかに拡散する光のエフェクトをつくります。
 
-----------------
 ````
 func design( screen:PGScreen ) {
     screen.clearColor = .darkGrey
 }

 func update( screen:PGScreen ) {
     for touch in screen.touches {
         for _ in 0 ..< 8 {
             let speed = (2.0...4.0).randomize
             let rad  = (0.0...2.0 * Double.pi).randomize
             
             PGAddBlurryCircle()
             .color( LLColor( 0.4, 0.6, 0.95, 1.0 ) )
             .position( touch.xy )
             .deltaPosition( 
                 dx: speed * cos( rad ),
                 dy: speed * sin( rad ) 
             )
             .scale(
                 width:(5.0...40.0).randomize,
                 height:(5.0...40.0).randomize )
             .angle( .random )
             .deltaAngle( degrees: (-2.0...2.0).randomize )
             .life( 1.0 )
             .deltaLife( -0.016 )
             .alpha( 1.0 )
             .deltaAlpha( -0.016 )
         }
     }
 }
 ````

---- 
1. design関数に ``screen.clearColor = .darkGrey`` を書きます。背景は濃い灰色です。
 
----
2. update関数を用意します。
 
----
3. ``for touch in screen.touches``でタッチのループを作ります。触れている指すべてをとらえます。
 
----
4. さらに、touchのループの中で``for _in 0 ..< 8``で8回ループを行い、
 加算合成のブラー円``PGAddBlurryCiecle()``を作ります。
 
----
5. 図形を動かすため、スピードと角度を計算した変数``speed``,``rad``を作ります。
   - ``speed``は2.0~4.0のランダム値、``rad``は0~2πのラジアンのランダム値です。
 
----
6. 初期設定のコードを書きます。
   - ``.color( LLColor( 0.4, 0.6, 0.95, 1.0 ) )``
      - 色。薄青を設定します。
 
   - ``.position( touch.xy )``
      - 位置。タッチ位置を設定します。
 
   - ``.deltaPosition( dx: speed * cos( rad ), dy: speed * sin( rad ) )``
      - 毎フレームの移動量。speedとradを用いて、タッチ位置から360度方向にランダムに飛び散ります。
 
   - ``.scale( width:(5.0...40.0).randomize, height:(5.0...40.0).randomize )``
      - 大きさ。5.0~40.0のランダム値です。縦と横のサイズを一致させないことでランダムの楕円になります。
 
   - ``.angle( .random )``
      - 角度。ランダムを設定します。
 
   - ``.deltaAngle( degrees: (-2.0...2.0).randomize )``
      - 毎フレームの角度変化量。-2.0~2.0度でランダムに回転します。
 
   - ``.life( 1.0 )``
      - ライフ。1.0から開始します。
 
   - ``.deltaLife( -0.016 )``
      - 毎フレームのライフ変化量。-0.016で約60フレームでライフが0になります。
 
   - ``.alpha( 1.0 )``
      - アルファ。1.0を設定します。
 
   - ``.deltaAlpha( -0.016 )``
      - 毎フレームのアルファ変化量。-0.016で約60フレームで透明になります。 
 
----
 7. 「コードを実行」を押します。
 
-----------------
## 目標
+ 実行後、タッチ位置から青い光が飛び散れば成功です。 [**結果の例**](glossary://result-3-2-1)

-----------------
[次のページ](@next)

*/

//#-editable-code
func design( screen:PGScreen ) {
    screen.clearColor = .darkGrey
}

func update( screen:PGScreen ) {

}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design
vc.pgUpdateHandler = update

//#-end-hidden-code
