//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, coordRegion, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, screen, clearColor, latestTouch, removeAllShapes )
//#-code-completion(identifier, show, xy )
//#-code-completion(identifier, show, touches, . )
//#-code-completion(identifier, show, count )
/*:#localized( key:"--explain" )
# 2-2. シャワー
 
[前のページ](@previous)

このページでは、タッチ位置から水が噴き出すシャワーを表現してみましょう。

-----------------
 ````
 func design( screen:PGScreen ) {
     screen.clearColor = .darkGrey
 }

 func update( screen:PGScreen ) {
     for touch in screen.touches {
         for _ in 0 ..< 16 {
             PGAddBlurryCircle()
             .color( LLColor( 0.16, 0.3, 0.5, 0.8 ) )
             .position( 
                 cx: touch.x + (-5.0...5.0).randomize,
                 cy: touch.y + (-5.0...5.0).randomize
             ) 
             .deltaPosition( 
                 dx:(-1.0...1.0).randomize,
                 dy:(1.0...3.0).randomize
             )
             .scale( square: 24.0 )
             .iterate {
                 $0.deltaPosition.y -= 0.25
                 
                 if $0.position.y < Float( screen.minY ) {
                     $0.life( 0.0 )
                 }
             }
         }
     }
 }
 ````
 
----
1. design関数に ``screen.clearColor = .darkGrey`` を書きます。背景は濃い灰色です。
 
----
2. update関数を用意します。
 
----
3. ``for touch in screen.touches``でタッチのループを作ります。触れている指すべてをとらえます。
 
----
4. 3のループ内で``for _ in 0 ..< 16``を書き、 加算合成のブラー円``PGAddBlurryCiecle()``を作ります。
 
----
5. 初期設定のコードを書きます。
   - ``.color( LLColor( 0.16, 0.3, 0.5, 0.8 ) )``
      - 色。重なると薄青になるような色を指定します。

   - ``.position( cx: touch.x + (-5.0...5.0).randomize, cy: touch.y + (-5.0...5.0).randomize )`` 
      - 位置。タッチ位置から-5.0~5.0のブレがある範囲を設定します。
 
   - ``.deltaPosition( dx:(-1.0...1.0).randomize, dy:(1.0...3.0).randomize )``
      - 毎フレームの移動量。dxは左右方向にわずかな移動,dyは上方向に向いた移動を行うよう設定します。
 
   - ``.scale( square: 24.0 )``
      - 大きさ。24.0で固定です。
 
---- 
6. ``.iterate{ }`` を用意して、毎フレームのdeltaPositionを変化します。
   - ``$0.deltaPosition.y -= 0.25``
      - y方向の移動量を-0.25していきます。
 
  上記の計算により、だんだんと上方向への移動量が減り、下に落ちるようになります。
 
----
7. ``if $0.position.y < Float( screen.minY )``で画面の一番下に到達したかを判定します。
   - 画面下に到達したら``$0.life( 0.0 )``で、図形を消去します。

----  
8. 「コードを実行」を押します。
 
-----------------
## 目標
+ 実行後、タッチの軌跡が描ければ成功です。 [**結果の例**](glossary://result-3-2-2)

-----------------
[次のページ](@next)

*/

//#-editable-code
func design( screen:PGScreen ) {
    screen.clearColor = .darkGrey
}

func update( screen:PGScreen ) {

}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design
vc.pgUpdateHandler = update

//#-end-hidden-code
