//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, coordRegion, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, screen, clearColor, latestTouch, removeAllShapes )
//#-code-completion(identifier, show, xy )
//#-code-completion(identifier, show, touches, . )
//#-code-completion(identifier, show, count )
/*:#localized( key:"--explain" )
# 2-4. 燃える軌跡

[前のページ](@previous)

このページでは、なぞった位置から炎が立ち上がるエフェクトを作ってみましょう。
  
-----------------
````
func design( screen:PGScreen ) {
 screen.clearColor = .darkGrey
}

func update( screen:PGScreen ) {
    for touch in screen.touches {
        for _ in 0 ..< 2 {
            PGAddMask( "mask-smoke" )
            .color( LLColor( 1.0, 0.4, 0.3, 1.0 ) )
            .position( 
                cx: touch.x + (-4.0...4.0).randomize,
                cy: touch.y + (-4.0...4.0).randomize
            )
            .deltaPosition(
                dx: (-1.0...1.0).randomize,
                dy: (2.0...3.0).randomize
            )
            .scale( square:(20.0...90.0).randomize )
            .deltaScale(
                dw:1.0,
                dh:1.0
            )
            .angle( .random )
            .deltaAngle( degrees:(-2.0...2.0).randomize )
            .deltaLife( -0.02 )
            .iterate {
                $0.alpha = $0.life
                $0.color.R -= 0.02
                $0.color.G -= 0.009
                $0.color.B -= 0.007
            }
        }
    }
}
````
 
----
1. design関数に ``screen.clearColor = .darkGrey`` を書きます。背景は濃い灰色です。

----
2. update関数を用意します。

----
3. ``for touch in screen.touches``でタッチのループを作ります。触れている指すべてをとらえます。

----
4. 3のループ内で``for _ in 0 ..< 2``を書き、 加算合成の煙模様``PGAddMask( "mask-smoke" )``を作ります。

----
5. 図形の初期設定のコードを書きます。
   - ``.color( LLColor( 1.0, 0.4, 0.3, 1.0 ) )``
      - 色。明るい赤色を設定します。少しだけ黄色に近づけます。
 
   - ``.position( cx:touch.x + (-4.0...4.0).randomize, cy:touch.y + (-4.0...4.0).randomize )``
      - 位置。タッチ位置から-4.0~4.0のランダム値を設定します。
 
   - ``.deltaPosition( dx:(-1.0...1.0).randomize, dy:(2.0...3.0).randomize )``
      - 位置の変化量。x方向は-1.0~1.0のランダム値で横にわずかに移動します。y方向は2.0~3.0のランダム値で上方向に移動します。
 
   - ``.scale( square:(20.0...90.0).randomize )``
      - 大きさ。20.0~90.0のランダム値で色々な大きさをとります。

   - ``.deltaScale( dw:1.0, dh:1.0 )``
      - 大きさの変化量。毎フレーム1.0ずつ大きくしていきます。
 
   - ``.angle( .random )``
      - 初期の角度。ランダムを設定します。
 
   - ``.deltaAngle( degrees:(-2.0...2.0).randomize )``
      - 角度の変化量。毎フレーム-2.0~2.0のランダム値で回転します。
 
   - ``.deltaLife( -0.02 )``
      - ライフの変化量。-0.02を設定し、50フレームで図形が消えるようにします。
 
---- 
6. ``.iterate{ }`` を用意して、毎フレームの計算を行います。
   - ``$0.alpha = $0.life``
      - アルファ値をライフと同じ値にします。
 
   - ``$0.color.R -= 0.02``
      - 色のRed値を0.02引き算します。
 
   - ``$0.color.G -= 0.009``
      - 色のGreen値を0.009引き算します。
 
   - ``$0.color.B -= 0.007``
      - 色のBlue値を0.007引き算します。
 
 上記の計算により、時間が経つごとに薄くなりながら、少しずつ灰色に近づきます。
 
----
7. 「コードを実行」を押します。
 
-----------------
## 目標
+ 実行後、タッチ位置から炎が立ちのぼるエフェクトが描ければ成功です。 [**結果の例**](glossary://result-3-2-4)

-----------------
[次のページ](@next)
 
*/

//#-editable-code
func design( screen:PGScreen ) {
    screen.clearColor = .darkGrey
}

func update( screen:PGScreen ) {

}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design
vc.pgUpdateHandler = update

//#-end-hidden-code
