//#-hidden-code
//
// LilySwift Playground
//
// Copyright (c) Watanabe-Denki, Inc.
//   https://wdkk.co.jp/
//
//#-end-hidden-code
//#-hidden-code
import UIKit
import LilySwiftForPlayground
let vc = setupPG()
//#-end-hidden-code
//#-code-completion(module, hide, Swift)
//#-code-completion(everything, hide)
//#-code-completion(identifier, hide, setupPG())
//#-code-completion(identifier, show, +, -, *, /, % )
//#-code-completion(identifier, show, for, if, {, }, <, >, ..<, ... )
//#-code-completion(identifier, show, _ )
//#-code-completion(identifier, show, let, var, = )
//#-code-completion(identifier, show, PGRectangle )
//#-code-completion(identifier, show, PGCircle )
//#-code-completion(identifier, show, PGTriangle )
//#-code-completion(identifier, show, PGBlurryCircle )
//#-code-completion(identifier, show, PGPicture )
//#-code-completion(identifier, show, PGMask )
//#-code-completion(identifier, show, PGAddRectangle )
//#-code-completion(identifier, show, PGAddCircle )
//#-code-completion(identifier, show, PGAddTriangle )
//#-code-completion(identifier, show, PGAddBlurryCircle )
//#-code-completion(identifier, show, PGAddPicture )
//#-code-completion(identifier, show, PGAddMask )
//#-code-completion(identifier, show, color(c:LLColor), color(red:green:blue:) )
//#-code-completion(identifier, show, scale, scale(square:), scale(width:height:) )
//#-code-completion(identifier, show, position, position(cx:cy:) )
//#-code-completion(identifier, show, angle, angle(degrees:), angle(radians:) )
//#-code-completion(identifier, show, coordRegion, randomPoint, .randomPoint )
//#-code-completion(identifier, show, random, .random )
//#-code-completion(identifier, show, randomize, .randomize )
//#-code-completion(identifier, show, deltaPosition, deltaPosition(dx:dy:) )
//#-code-completion(identifier, show, screen, clearColor, latestTouch, removeAllShapes )
//#-code-completion(identifier, show, xy )
//#-code-completion(identifier, show, touches, . )
//#-code-completion(identifier, show, count )
/*:#localized( key:"--explain" )
# 2-5. 離した時に光線を描く

[前のページ](@previous)

ここでは趣向を変えて、 指を離した時に指の移動した方向に光の線を描きます。
 
-----------------

````
func design( screen:PGScreen ) {
    screen.clearColor = .darkGrey
}

func update( screen:PGScreen ) {  
    for release in screen.releases {
        for k in 0 ..< 4 {
            let dx = release.x - release.startPos.x
            let dy = release.y - release.startPos.y
            let angle = Double( atan2( dy, dx ) )
            let base_size = Float( 40 + 10 * k )
            
            PGAddBlurryCircle()
            .color( LLColor( 0.2, 0.4, 0.6, 1.0 ) )
            .position( release.startPos )
            .angle( radians:angle )
            .deltaPosition( 
                dx: dx * 0.08,
                dy: dy * 0.08
            )
            .deltaLife( -0.02 )
            .scale( square: base_size )
            .iterate {                
                $0.deltaPosition.x *= 0.93
                $0.deltaPosition.y *= 0.93
                 
                let speed = sqrt(
                    $0.deltaPosition.x * $0.deltaPosition.x + 
                    $0.deltaPosition.y * $0.deltaPosition.y
                ) 
                 
                $0
                .width( base_size * ( 1.0 + speed / 10.0 ) )
                .alpha( $0.life )
            }
        }
    }
}
````
 
----
1. design関数に ``screen.clearColor = .darkGrey`` を書きます。背景は濃い灰色です。

----
2. update関数を用意します。

----
3. ``for release in screen.releases``でリリースのループを作ります。離れた指をとらえます。

----
4. 3のループ内で``for k in 0 ..< 4``を書き、 加算合成のブラー円``PGAddBlurryCircle()``を作ります。ブラー円を4つ重ねます。

----
5. 図形の初期化に用いる値を計算し、変数に代入します。
   - ``let dx = release.x - release.startPos.x``
      - タッチを始めた位置(release.startPos)、指を離した位置(release)のx方向の距離をdxに代入します。
 
   - ``let dy = release.y - release.startPos.y``
      - タッチを始めた位置(release.startPos)、指を離した位置(release)のy方向の距離をdyに代入します。

 
   - ``let angle = Double( atan2( dy, dx ) )``
      - dx, dyを使って図形の角度を計算します。atan2という関数で角度が得られます。
 
   - ``let base_size = Float( 40 + 10 * k )``
      - 4つのブラー円の大きさです。kを使って少しずつ大きくした円を重ねます。
 
----
6. 図形の初期設定のコードを書きます。
   - ``.color( LLColor( 0.2, 0.4, 0.6, 1.0 ) )``
      - 色。薄青を設定します。
 
   - ``.position( release.startPos )``
      - 位置。タッチした初期位置を設定します。
 
   - ``.angle( radians:angle )``
      - 角度。計算したangleを設定します。進む方向に傾けます。
 
   - ``.deltaPosition( dx: dx * 0.08, dy: dy * 0.08 )``
      - 位置の変化量。計算したdx,dyを0.08倍して設定します。
 
   - ``.deltaLife( -0.02 )``
      - ライフの変化量。50フレームで図形が消えるようにします。
 
   - ``.scale( square: base_size )``
      - 大きさ。計算したbase_sizeを設定します。
 
---- 
8. ``.iterate{ }`` を用意して、毎フレームで計算を行います。
   - ``$0.deltaPosition.x *= 0.93``
      - x移動量に0.93を掛けて、フレームごとに移動量を減らしていきます。
 
   - ``$0.deltaPosition.y *= 0.93``
      - y移動量に0.93を掛けて、フレームごとに移動量を減らしていきます。
 
   - ``let speed = sqrt( $0.deltaPosition.x * $0.deltaPosition.x + $0.deltaPosition.y * $0.deltaPosition.y )``
      - deltaPositionからスピードを計算します。
 
   - ``$0.width( base_size * ( 1.0 + speed / 10.0 ) )``
      - スピードによって図形の幅を変えます。速度に合わせて図形が伸びます。
 
   - ``.alpha( $0.life )``
      - アルファをライフと同じ値にします。
 
---- 
9. 「コードを実行」を押します。
 
-----------------
## 目標
+ 実行後、指を離した時に、光線が飛ぶ表現ができれば成功です。 [**結果の例**](glossary://result-3-2-5)

-----------------
[次のページ](@next)
 
*/

//#-editable-code
func design( screen:PGScreen ) {
    screen.clearColor = .darkGrey
}

func update( screen:PGScreen ) {

}
//#-end-editable-code
//#-hidden-code

vc.pgDesignHandler = design
vc.pgUpdateHandler = update

//#-end-hidden-code
